window.addEventListener("elementor:init", () => {
  const RepeaterControl = elementor.modules.controls.BaseData.extend({
    onReady: function () {
      // const $repeater = this.$el.find(".gbx-arg-repeater");
      const that = this;

      this.repeater = this.$el.find(".gbx-arg-repeater").repeater({
        initEmpty: true,
        defaultValues: {},
        dragDrop: false,
        show: function () {
          jQuery(this).slideDown();
          const $taxonomySelect = jQuery(this).find(".gbx-taxonomy-selector");

          const $repeater_item = jQuery(this).find(
            ".gbx-arg-group-inline-fields"
          );

          const taxonomyValue = $taxonomySelect.val();

          const $taxonomySelectTerm = jQuery(this).find(
            ".gbx-taxonomy-term-selector"
          );

          $taxonomySelect.on("change", () => {
            const taxonomyValue = $taxonomySelect.val();
          });

          $taxonomySelectTerm
            .select2({
              multiple: true,
              ajax: {
                url:
                  gbxArgsControl.ajax_url +
                  "?action=gbx_select_taxonomy_control",
                dataType: "json",
                data: function (params) {
                  const query = {
                    search: params.term,
                    nonce: gbxArgsControl.nonce,
                    taxonomy: taxonomyValue,
                  };
                  return query;
                },
                processResults: function (data) {
                  save_data = data;

                  return {
                    results: data,
                  };
                },
                reportError: function (error) {
                  console.log("Error", error);
                },
              },
            })
            .on("change", () => {
              that.saveValue(); // errror here
            });

          //this is to reset the select2 when the taxonomy is changed
          $taxonomySelect.on("change", () => {
            //reset the select2
            $taxonomySelectTerm.val(null).trigger("change");

            const taxonomyValue = $taxonomySelect.val();

            $taxonomySelectTerm.select2({
              multiple: true,
              ajax: {
                url:
                  gbxArgsControl.ajax_url +
                  "?action=gbx_select_taxonomy_control",
                dataType: "json",
                data: function (params) {
                  const query = {
                    search: params.term,
                    nonce: gbxArgsControl.nonce,
                    taxonomy: taxonomyValue,
                  };
                  return query;
                },
                processResults: function (data) {
                  save_data = data;

                  return {
                    results: data,
                  };
                },
                reportError: function (error) {
                  console.log("Error", error);
                },
              },
            });
          });
        },
        hide: function (deleteElement) {
          jQuery(this).slideUp(deleteElement);
          setTimeout(
            function () {
              this.saveValue();
            }.bind(this),
            1000
          );
        }.bind(this),
        isFirstItemUndeletable: true,
      });

      // hadlign the data loading here
      var dataElementor = this.getControlValue();
      if (dataElementor) {
        var myObj = JSON.parse(dataElementor);
        this.repeater.setList(myObj["gbx-arg-group-a"]);
      }

      this.$el.on("DOMNodeInserted", ".gbx-arg-repeater-item", function (e) {
        const $repeaterItem = jQuery(e.target);
        const itemIndex = that.$el
          .find(".gbx-arg-repeater-item")
          .index($repeaterItem);

        if (
          myObj &&
          myObj["gbx-arg-group-a"] &&
          myObj["gbx-arg-group-a"][itemIndex]
        ) {
          const item = myObj["gbx-arg-group-a"][itemIndex];
          const $taxonomySelectTerm = $repeaterItem.find(
            ".gbx-taxonomy-term-selector"
          );

          if (item.taxonomyterms) {
            item.taxonomyterms.forEach((term) => {
              const termData = {
                id: term.split("|")[0],
                text: term.split("|")[1],
              };
              const option = new Option(termData.text, termData.id, true, true);
              $taxonomySelectTerm.append(option).trigger("change");
            });
          }
        }
      });
    },
    saveValue() {
      var result = this.repeater.repeaterVal();
      var sa = JSON.stringify(result);
      this.setValue(sa);
    },

    onBeforeDestroy() {
      this.saveValue();
    },
  });

  elementor.addControlView("args_builder", RepeaterControl);
});
