window.addEventListener("elementor/init", () => {
  var RepeaterControl = elementor.modules.controls.BaseData.extend({
    onReady: function () {
      this.conditional = this.$el.find(".gbx-repeater");
      this.repeater = this.$el.find(".gbx-repeater").repeater({
        initEmpty: true,
        defaultValues: {},
        dragDrop: true,
        show: function () {
          jQuery(this).slideDown();
        },
        hide: function (deleteElement) {
          jQuery(this).slideUp(deleteElement);

          setTimeout(
            function () {
              this.saveValue();
            }.bind(this),
            2000
          );
        }.bind(this),
        isFirstItemUndeletable: true,
      });

      this.conditional.on("change", () => {
        this.saveValue();
      });

      var dataElementor = this.getControlValue();
      if (dataElementor) {
        var myObj = JSON.parse(dataElementor);
        this.repeater.setList(myObj["gbx-group-a"]);
      }
    },

    saveValue() {
      var result = jQuery(".gbx-repeater").repeaterVal();
      var data = JSON.stringify(result);
      this.setValue(data);
    },

    onBeforeDestroy() {
      this.saveValue();
    },
  });

  elementor.addControlView("dynamic_field_select", RepeaterControl);
});
