/* eslint-disable no-undef */
(function ($) {
  "use strict";

  var GbxFiltersHandler = function ($scope, $) {
    $(".ui.dropdown").dropdown();

    $(".gbx__filter__slider__input").each(function () {
      var sliderElement = $(this);

      var startValue = sliderElement.data("start");
      var minValue = Number(sliderElement.data("min"));
      var maxValue = Number(sliderElement.data("max"));
      var stepValue = Number(sliderElement.data("step"));

      // convert to string and remove spaces
      startValue = startValue.toString();
      startValue = startValue.replace(/\s+/g, "");

      // If contains a comma, it's a range then split it and make it an array of numbers
      if (startValue.indexOf(",") !== -1) {
        startValue = startValue.split(",").map(Number);
      } else {
        // If not, it's a single value then convert it to a number
        startValue = Number(startValue);
      }

      // Check if the slider element exists before initializing noUiSlider
      if (sliderElement.length > 0 && !sliderElement[0].noUiSlider) {
        // Initialize the noUiSlider instance
        // eslint-disable-next-line no-undef
        noUiSlider.create(sliderElement[0], {
          start: startValue,
          connect: true,
          range: {
            min: minValue,
            max: maxValue,
          },
          tooltips: true,
          step: stepValue,
        });
      }
    });
  };

  window.copyWidgetId = function (id) {
    var el = document.createElement("textarea");
    el.value = id;
    document.body.appendChild(el);
    el.select();
    document.execCommand("copy");
    document.body.removeChild(el);
    alert("Widget ID copied to clipboard: " + id);
  };

  var GbxHandler = function ($scope, $) {
    function revealOnScroll() {
      const gridItems = document.querySelectorAll(
        ".grid__item__animated:not([data-revealed])"
      );
      gridItems.forEach((item, index) => {
        setTimeout(() => {
          item.classList.add("visible");
          item.setAttribute("data-revealed", "true");
        }, index * 50); // Adjust the delay (100ms) as needed
      });
    }

    // Initial reveal on page load
    revealOnScroll();
  };

  // Make sure you run this code under Elementor.
  $(window).on("elementor/frontend/init", function () {
    elementorFrontend.hooks.addAction(
      "frontend/element_ready/grid-builder-x-filter.default",
      GbxFiltersHandler
    );
  });

  // Make sure you run this code under Elementor.
  $(window).on("elementor/frontend/init", function () {
    elementorFrontend.hooks.addAction(
      "frontend/element_ready/grid-builder-x.default",
      GbxHandler
    );
  });
})(jQuery);
