window.addEventListener("elementor:init", () => {
  const FilterTaxonomySearchControl =
    elementor.modules.controls.BaseData.extend({
      onReady: function () {
        const that = this;

        const $taxonomySelect = this.$el.find(".gbx-taxonomy-selector");

        const taxonomyValue = $taxonomySelect.val();

        const $taxonomySelectTerm = this.$el.find(
          ".gbx-taxonomy-term-selector"
        );

        $taxonomySelect.on("change", () => {
          const taxonomyValue = $taxonomySelect.val();
        });

        $taxonomySelectTerm
          .select2({
            multiple: true,
            ajax: {
              url:
                gbxTaxonomyFilterControl.ajax_url +
                "?action=gbx_select_taxonomy_control_filter",
              dataType: "json",
              data: function (params) {
                const query = {
                  search: params.term,
                  nonce: gbxTaxonomyFilterControl.nonce,
                  taxonomy: taxonomyValue,
                };
                return query;
              },
              processResults: function (data) {
                return {
                  results: data,
                };
              },
              reportError: function (error) {
                console.log("Error", error);
              },
            },
          })
          .on("change", () => {
            that.saveValue();
          });

        $taxonomySelect.on("change", () => {
          $taxonomySelectTerm.val(null).trigger("change");

          const taxonomyValue = $taxonomySelect.val();

          $taxonomySelectTerm.select2({
            multiple: true,
            ajax: {
              url:
                gbxTaxonomyFilterControl.ajax_url +
                "?action=gbx_select_taxonomy_control_filter",
              dataType: "json",
              data: function (params) {
                const query = {
                  search: params.term,
                  nonce: gbxTaxonomyFilterControl.nonce,
                  taxonomy: taxonomyValue,
                };
                return query;
              },
              processResults: function (data) {
                return {
                  results: data,
                };
              },
              reportError: function (error) {
                console.log("Error", error);
              },
            },
          });
        });
      },
      saveValue() {
        const selectedTerms = this.$el
          .find(".gbx-taxonomy-term-selector")
          .select2("data");
        const result = {
          taxonomy: this.$el.find(".gbx-taxonomy-selector").val(),
          taxonomyterms: selectedTerms.map((term) => term.id + "|" + term.text),
        };

        this.setValue(JSON.stringify(result));
      },

      onBeforeDestroy() {
        this.saveValue();
      },
    });

  elementor.addControlView(
    "filter_taxonomy_search_control",
    FilterTaxonomySearchControl
  );
});
