window.addEventListener("elementor:init", () => {
  const SearchControl = elementor.modules.controls.BaseData.extend({
    // search posts elementor control

    onReady: function () {
      const that = this;
      const $searchPostsSelect = this.$el.find(".gbx-select-posts-selector");

      $searchPostsSelect
        .select2({
          multiple: true,
          ajax: {
            url:
              gbxSearchPosts.ajax_url +
              "?action=gbx_select_search_posts_control",
            dataType: "json",
            data: function (params) {
              const query = {
                search: params.term,
                nonce: gbxSearchPosts.nonce,
              };
              return query;
            },
            processResults: function (data) {
              //   save_data = data;
              return {
                results: data,
              };
            },
            reportError: function (error) {
              console.log("Error", error);
            },
          },
        })
        .on("change", () => {
          that.saveValue();
        });
    },

    saveValue: function () {
      $searchPostsSelect = this.$el.find(".gbx-select-posts-selector");
      const value = $searchPostsSelect.val();

      var sa = JSON.stringify(value);

      this.setValue(sa);
    },
    onBeforeDestroy: function () {
      //   $searchPostsSelect.select2("destroy");
    },
  });
  elementor.addControlView("gbx-search-posts", SearchControl);
});
