<?php

namespace GRIDBUILDERX\Controls;

// If this file is called directly, abort.
if (!defined('WPINC')) {
    die;
}

use Elementor\Base_Data_Control;

class Dynamic_Field_Select_Control extends Base_Data_Control
{

    public function get_type()
    {
        return 'dynamic_field_select';
    }

    public function enqueue()
    {

        wp_register_script('gbx-repeater', GBX_PLUGIN_URL . 'assets/js/repeater.js', ['jquery'], GBX_VERSION, true);

        wp_register_script('gbx-dynamic-field-select-control', GBX_PLUGIN_URL . 'assets/js/dynamic-field-select-control.js', ['jquery', 'gbx-repeater'], GBX_VERSION, true);
        wp_enqueue_script('gbx-dynamic-field-select-control');

        //css file
        wp_register_style('gbx-dynamic-field-select-control', GBX_PLUGIN_URL . 'assets/css/dynamic-field-select-control.css', [], GBX_VERSION);
        wp_enqueue_style('gbx-dynamic-field-select-control');
    }


    public function content_template()
    {
?>
        <# if ( data.label ) {#>
				<label for="<?php $this->print_control_uid(); ?>" class="elementor-control-title">{{{ data.label }}}</label>
			<# } #>
        <div class="gbx-repeater gbx-inner-repeater" data-setting="{{ data.name }}">
                <div data-repeater-list="gbx-group-a" class="gbx-repeater-list"> 
                                 
                    <div data-repeater-item class="gbx-repeater-item">
                        <div class="gbx-group-inline-fields">
                            <div class="gbx-group-inner">
                                <label class="elementor-control-title">Field Key</label>
                                <select class="gbx-8px-styler" name="fieldkey">
                                <# _.each( data.acf_fields, function( option_title, option_value ) {
                                    var value = data.controlValue;
                                    if ( typeof value == 'string' ) {
                                        var selected = ( option_value === value ) ? 'selected' : '';
                                    } else if ( null !== value ) {
                                        var value = _.values( value );
                                        var selected = ( -1 !== value.indexOf( option_value ) ) ? 'selected' : '';
                                    }
                                #>
                                <option {{ selected }} value="{{ option_value }}">{{{ option_title }}}</option>
					            <# } ); #>
                                </select>
                            </div>
                            <div class="gbx-group-inner">
                                <label class="elementor-control-title">Condition</label>
                                <select class="gbx-8px-styler" name="condition">
                                <# _.each( data.options, function( option_title, option_value ) {
                                    var value = data.controlValue;
                                    if ( typeof value == 'string' ) {
                                        var selected = ( option_value === value ) ? 'selected' : '';
                                    } else if ( null !== value ) {
                                        var value = _.values( value );
                                        var selected = ( -1 !== value.indexOf( option_value ) ) ? 'selected' : '';
                                    }
                                #>
                                <option {{ selected }} value="{{ option_value }}">{{{ option_title }}}</option>
					            <# } ); #>
                                </select>
                            </div>
                            <div class="gbx-group-inner">
                            <label class="elementor-control-title">Field Value</label>
                                <input class="gbx-8px-styler" type="text" name="fieldvalue" value="A"/>
                            </div>
                            <div class="gbx-group-inner gbx-delete-button-c1">
                                <input class="gbx-button-reseter-style" data-repeater-delete type="button" value="X"/>
                            </div>
                        </div>
                    </div>
                </div>
                <input data-repeater-create type="button" value="Add Condition"/>
        </div>
    
       <# if ( data.description ) { #>
			<div class="elementor-control-field-description">{{{ data.description }}}</div>
		<# } #>
<?php
    }
}
