<?php

namespace GRIDBUILDERX\Controls;

// If this file is called directly, abort.
if (!defined('WPINC')) {
    die;
}

use Elementor\Base_Data_Control;

class Filter_Taxonomy_Search_Control extends Base_Data_Control
{

    public function get_type()
    {
        return 'filter_taxonomy_search_control';
    }

    public function enqueue()
    {

        wp_register_script('gbx-filter-taxonomy-control', GBX_PLUGIN_URL . 'assets/js/filter-taxonomy-search-control.js', ['jquery'], GBX_VERSION, true);
        wp_enqueue_script('gbx-filter-taxonomy-control');

        wp_localize_script('gbx-filter-taxonomy-control', 'gbxTaxonomyFilterControl', [
            'ajax_url' => admin_url('admin-ajax.php'),
            'nonce' => wp_create_nonce('gbx-filter-taxonomy-control-nonce'),
        ]);
    }


    public function content_template()
    {
?>
        <# if ( data.label ) {#>
            <label for="<?php $this->print_control_uid(); ?>" class="elementor-control-title">{{{ data.label }}}</label>
        <# } #>
    
        <div class="gbx-arg-group-inline-fields" data-setting="{{ data.name }}">
            <div class="gbx-arg-group-inner">
                <select id="<?php $this->print_control_uid(); ?>" name="taxonomy" class="elementor-select2 gbx-taxonomy-selector" >
                    <# _.each( data.taxonomy, function( option_title, option_value ) {
                        var controlValue = data.controlValue;
                        if (controlValue) {
                            var controlValueJson = JSON.parse(controlValue);
                          
                            var selected = ( option_value === controlValueJson.taxonomy ) ? 'selected' : '';
                           
                        } else {
                            var selected = '';
                        }
                        #>
                    <option {{ selected }} value="{{ option_value }}">{{{ option_title }}}</option>
                    <# } ); #>
                    
                </select>
            </div>
            <div class="gbx-arg-group-inner">
                <div class="tiatki-control-unit">
                    <select name="taxonomyterms" multiple="multiple" type="select2" class="gbx-taxonomy-term-selector" >
                        <#
                        var controlValue = data.controlValue;
                        if(controlValue){
                            var controlValueJson = JSON.parse(controlValue);
                            var selections = controlValueJson['taxonomyterms'];
                            _.each(selections, function(term) {
                                var option = term.split('|');
                                #>
                                <option value="{{ option[0]+'|'+option[1] }}" selected="selected">{{ option[1] }}</option>
                        <# }); 
                        }
    
                        #>                         
                    </select>
                </div>
            </div>                                  
        </div>
    
        <# if ( data.description ) { #>
            <div class="elementor-control-field-description">{{{ data.description }}}</div>
        <# } #>
    <?php
    }
}
