<?php

namespace GRIDBUILDERX\Controls;

// If this file is called directly, abort.
if (!defined('WPINC')) {
    die;
}

use Elementor\Base_Data_Control;

class Control_Search_Posts extends Base_Data_Control
{
    public function get_type()
    {
        return 'gbx-search-posts';
    }

    public function enqueue()
    {
        wp_register_script('gbx-search-posts', GBX_PLUGIN_URL . 'assets/js/search-posts.js', ['jquery'], GBX_VERSION, true);
        wp_enqueue_script('gbx-search-posts');

        wp_localize_script('gbx-search-posts', 'gbxSearchPosts', [
            'ajax_url' => admin_url('admin-ajax.php'),
            'nonce' => wp_create_nonce('gbx-search-posts-nonce'),
        ]);
    }

    public function content_template()
    {
?>

        <# if ( data.label ) {#>
			<label for="<?php $this->print_control_uid(); ?>" class="elementor-control-title">{{{ data.label }}}</label>
		<# } #>

        <div class="gbx-select-posts">
            <div class="gbx-select-posts-unit">
                <select name="selectposts" multiple="multiple" type="select2" class="gbx-select-posts-selector" >
                    <#
                    var controlValue = data.controlValue;
                    if(controlValue){
                        var selections = JSON.parse(controlValue);
                    
                        var options = [];

                        _.each(selections, function(term) {        
                            var option = term.split('|');
                            options.push(option);   
                        });
                      

                        _.each(options, function(option) { #>
                            <option value="{{ option[0]+'|'+option[1] }}" selected="selected">{{ option[1] }}</option>
                        <# }); 
                    }

                    #>                         
                </select>
            </div>
        </div>  

        <# if ( data.description ) { #>
			<div class="elementor-control-field-description">{{{ data.description }}}</div>
		<# } #>
 <?php
    }
}
