<?php

namespace GRIDBUILDERX\Controls;

// If this file is called directly, abort.
if (!defined('WPINC')) {
    die;
}

use Elementor\Base_Data_Control;

class Args_Builder_Control extends Base_Data_Control
{

    public function get_type()
    {
        return 'args_builder';
    }

    public function enqueue()
    {

        wp_register_script('gbx-repeater', GBX_PLUGIN_URL . 'assets/js/repeater.js', ['jquery'], GBX_VERSION, true);

        wp_register_script('gbx-args-control', GBX_PLUGIN_URL . 'assets/js/args-builder-control.js', ['jquery', 'gbx-repeater'], GBX_VERSION, true);
        wp_enqueue_script('gbx-args-control');

        //css file
        wp_register_style('gbx-args-control', GBX_PLUGIN_URL . 'assets/css/args-builder-control.css', [], GBX_VERSION);
        wp_enqueue_style('gbx-args-control');

        wp_localize_script('gbx-args-control', 'gbxArgsControl', [
            'ajax_url' => admin_url('admin-ajax.php'),
            'nonce' => wp_create_nonce('gbx-ags-control-nonce'),
        ]);
    }


    public function content_template()
    {
?>
        <# if ( data.label ) {#>
				<label for="<?php $this->print_control_uid(); ?>" class="elementor-control-title">{{{ data.label }}}</label>
			<# } #>
        <div class="gbx-arg-repeater gbx--arg-inner-repeater" data-setting="{{ data.name }}">
                <div data-repeater-list="gbx-arg-group-a" class="gbx-arg-repeater-list">                         
                    <div data-repeater-item class="gbx-arg-repeater-item">
                        <div class="gbx-arg-group-inline-fields">
                            <div class="gbx-arg-group-inner">                  
                                <select name="taxonomy" class="elementor-select2 gbx-taxonomy-selector" type="select2"  data-setting="{{ data.name }}">
                                    <# _.each( data.taxonomy, function( option_title, option_value ) {
                                        var value = data.controlValue;
                                        if ( typeof value == 'string' ) {
                                            var selected = ( option_value === value ) ? 'selected' : '';
                                        } else if ( null !== value ) {
                                            var value = _.values( value );
                                            var selected = ( -1 !== value.indexOf( option_value ) ) ? 'selected' : '';
                                        }
                                        #>
                                    <option {{ selected }} value="{{ option_value }}">{{{ option_title }}}</option>
                                    <# } ); #>
                                </select>
                            </div>
                            <div class="gbx-arg-group-inner">
                                <div class="tiatki-control-unit">
                                    <select name="taxonomyterms" multiple="multiple" type="select2" class="gbx-taxonomy-term-selector" >
                                        <#
                                        var controlValue = data.controlValue;
                                                                       
                                        if(controlValue){
                                            var controlValuejson = JSON.parse(controlValue);
                                            var selections = controlValuejson['gbx-arg-group-a'];
                                    
                                            var options = [];

                                            _.each(selections, function(taxonomyterm) {        
                                                _.each(taxonomyterm["taxonomyterms"], function(term) {
                                                    var option = term.split('|');
                                                    options.push(option);     
                                                });
                                            });
                                    

                                            _.each(options, function(option) { #>
                                                <option value="{{ option[0]+'|'+option[1] }}" selected="selected">{{ option[1] }}</option>
                                            <# }); 
                                        }

                                        #>                         
                                    </select>
                                </div>
                            </div>                    
                            <div class="gbx-group-inner gbx-repeater-delete-c2">
                                <input class="gbx-repeater-delete" data-repeater-delete type="button" value="X"/>
                            </div>
                        </div>
                    </div>
                </div>
                <input data-repeater-create type="button" value="Add"/>
        </div>
    
       <# if ( data.description ) { #>
			<div class="elementor-control-field-description">{{{ data.description }}}</div>
		<# } #>
<?php
    }
}
