<?php

namespace GRIDBUILDERX;

if (!defined('ABSPATH')) {
    exit;
}

class Layout_Builder
{

    protected $layout;

    public $layout_settings;

    public function __construct($layout_settings)
    {
        $this->layout_settings = $layout_settings;
    }

    public function get_layout()
    {

        foreach ($this->layout_settings as $key => $single_layout_grid) {
            $this->layout['fields'][] = new Layout($single_layout_grid);
        }

        // convert the object to array
        $this->layout = json_decode(json_encode($this->layout), true);
        $filteredArray = $this->removeEmptyFields($this->layout);
        return $filteredArray;
    }

    private function removeEmptyFields(array $array): array
    {
        foreach ($array as $key => &$value) {
            if (is_array($value)) {
                $value = $this->removeEmptyFields($value);
                if (empty($value)) {
                    unset($array[$key]);
                }
            } else {
                if ($value === null || $value === '') {
                    unset($array[$key]);
                }
            }
        }
        return $array;
    }
}
