<?php

use GRIDBUILDERX\Utils;

use function PHPSTORM_META\type;

if (!defined('ABSPATH')) {
    exit; // Exit if accessed directly.
}




$repeater->add_control(
    'field_type',
    [
        'label'   => esc_html__('Field Type', 'gbx'),
        'type'    => \Elementor\Controls_Manager::CHOOSE,
        'default' => 'text',
        'options' => [
            'column'          => [
                'title' => esc_html__('Column', 'gbx'),
                'icon' => 'fa fa-columns',
            ],
            'text'          => [
                'title' => esc_html__('Text', 'gbx'),
                'icon' => 'fa fa-font',
            ],
            'image'          => [
                'title' => esc_html__('Image', 'gbx'),
                'icon' => 'fa fa-image',
            ],
            'button'         => [
                'title' => esc_html__('Button', 'gbx'),
                'icon' => 'fa fa-hand-pointer',
            ],
            'utilities'      => [
                'title' => esc_html__('Utilities', 'gbx'),
                'icon' => 'fa fa-cog',
            ],
            'meta'          => [
                'title' => esc_html__('Meta', 'gbx'),
                'icon' => 'fa fa-info-circle',
            ],
        ],
    ]
);



//image types
$repeater->add_control(
    'image_type',
    [
        'label'   => esc_html__('Image Type', 'gbx'),
        'type'    => \Elementor\Controls_Manager::SELECT,
        'default' => 'featured',
        'options' => [
            'featured'          => esc_html__('Featured Image', 'gbx'),
            'custom'            => esc_html__('Custom Field', 'gbx'),
            'acf'               => esc_html__('ACF Field', 'gbx'),
            'author_image'      => esc_html__('Author Image', 'gbx'),
        ],
        'condition'  => [
            'field_type' => ['image'],
        ],
    ]
);

// custom field key
$repeater->add_control(
    'custom_field_key_image',
    [
        'label'       => esc_html__('Custom Field Key', 'gbx'),
        'type'        => \Elementor\Controls_Manager::TEXT,
        'default'     => '',
        'label_block' => false,
        'condition'  => [
            'field_type' => ['image'],
            'image_type' => ['custom'],
        ],
    ]
);


// acf field key
// $repeater->add_control(
//     'acf_field_ke_image',
//     [
//         'label'       => esc_html__('ACF Field Key', 'gbx'),
//         'type'        => \Elementor\Controls_Manager::TEXT,
//         'default'     => '',
//         'label_block' => false,
//         'condition'  => [
//             'field_type' => ['image'],
//             'image_type' => ['acf'],
//         ],
//     ]
// );

// acf field select key use utils
$repeater->add_control(
    'acf_field_key_image',
    [
        'label'       => esc_html__('ACF Field Key', 'gbx'),
        'type'        => \Elementor\Controls_Manager::SELECT,
        'default'     => '',
        'label_block' => false,
        'options'     => GRIDBUILDERX\Utils::get_list_of_all_acf_fields(),
        'condition'  => [
            'field_type' => ['image'],
            'image_type' => ['acf'],
        ],
    ]
);



// select Text types
$repeater->add_control(
    'text_type',
    [
        'label'   => esc_html__('Text Type', 'gbx'),
        'type'    => \Elementor\Controls_Manager::SELECT,
        'default' => 'title',
        'options' => [
            'title'          => esc_html__('Post Title', 'gbx'),
            'plain_text'     => esc_html__('Plain Text', 'gbx'),
            'content'        => esc_html__('Content', 'gbx'),
            'excerpt'        => esc_html__('Excerpt', 'gbx'),
            'custom'         => esc_html__('Custom Field', 'gbx'),
            'acf'            => esc_html__('ACF Field', 'gbx'),
            'woocommerce'    => esc_html__('WooCommerce Field', 'gbx'),
        ],
        'condition'  => [
            'field_type' => ['text'],
        ],
    ]
);

// selet meta types
$repeater->add_control(
    'meta_type',
    [
        'label'   => esc_html__('Meta Type', 'gbx'),
        'type'    => \Elementor\Controls_Manager::SELECT,
        'default' => 'author',
        'options' => [
            'author'         => esc_html__('Author', 'gbx'),
            'date'            => esc_html__('Date', 'gbx'),
            'categories'      => esc_html__('Categories / Tags / Taxonomies', 'gbx'),
            'comments_number' => esc_html__('Comments Number', 'gbx'),
            'views'           => esc_html__('Views', 'gbx'),
        ],
        'condition'  => [
            'field_type' => ['meta'],
        ],
    ]
);


// custom field key
// $repeater->add_control(
//     'custom_field_key_text',
//     [
//         'label'       => esc_html__('Custom Field Key 2', 'gbx'),
//         'type'        => \Elementor\Controls_Manager::TEXT,
//         'default'     => '',
//         'label_block' => false,
//         'condition'  => [
//             'field_type' => ['text'],
//             'text_type' => ['custom'],
//         ],
//     ]
// );


// // video field key
// $repeater->add_control(
//     'video_field_key',
//     [
//         'label'       => esc_html__('Video Field ACF Key', 'gbx'),
//         'type'        => \Elementor\Controls_Manager::TEXT,
//         'default'     => '',
//         'label_block' => false,
//         'condition'  => [
//             'field_type' => ['video'],
//             'video_type' => ['acf'],
//         ],
//     ]
// );

// on hover play video
// $repeater->add_control(
//     'on_hover_play_video',
//     [
//         'label'        => esc_html__('On Hover Play Video', 'gbx'),
//         'type'         => \Elementor\Controls_Manager::SWITCHER,
//         'label_on'     => esc_html__('Yes', 'gbx'),
//         'label_off'    => esc_html__('No', 'gbx'),
//         'return_value' => 'yes',
//         'default'      => 'no',
//         'condition'  => [
//             'field_type' => ['video'],
//         ],
//     ]
// );

// select grid utilities
$repeater->add_control(
    'utility_type',
    [
        'label'   => esc_html__('Utility Type', 'gbx'),
        'type'    => \Elementor\Controls_Manager::SELECT,
        'default' => 'divider',
        'options' => [
            'divider'        => esc_html__('Divider', 'gbx'),
            'icon'           => esc_html__('Icon', 'gbx'),
            'shortcode'      => esc_html__('Shortcode', 'gbx'),
            'html'           => esc_html__('HTML', 'gbx'),
            // 'elementor_template' => esc_html__('Elementor Template', 'gbx'),
        ],
        'condition'  => [
            'field_type' => ['utilities'],
        ],
    ]
);

// icon selector control new in elementor 2.6
$repeater->add_control(
    'icon_custom_control',
    [
        'label'       => esc_html__('Icon', 'gbx'),
        'type'        => \Elementor\Controls_Manager::ICONS,
        'default'     => [
            'value'   => 'fas fa-star',
            'library' => 'solid',
        ],
        'label_block' => true,
        'condition'  => [
            'field_type' => ['utilities'],
            'utility_type' => ['icon'],
        ],
    ]
);

// shortcode field
$repeater->add_control(
    'shortcode',
    [
        'label'       => esc_html__('Shortcode', 'gbx'),
        'type'        => \Elementor\Controls_Manager::TEXT,
        'default'     => '',
        'label_block' => false,
        'condition'  => [
            'field_type' => ['utilities'],
            'utility_type' => ['shortcode'],
        ],
    ]
);

// html field
$repeater->add_control(
    'html',
    [
        'label'       => esc_html__('HTML', 'gbx'),
        'type'        => \Elementor\Controls_Manager::CODE,
        'default'     => '',
        'label_block' => true,
        'condition'  => [
            'field_type' => ['utilities'],
            'utility_type' => ['html'],
        ],
    ]
);

// elementor template selector
$repeater->add_control(
    'elementor_template',
    [
        'label'       => esc_html__('Elementor Template', 'gbx'),
        'type'        => \Elementor\Controls_Manager::SELECT,
        'default'     => '',
        'label_block' => false,
        'options'     => GRIDBUILDERX\Utils::get_list_of_all_elementor_templates(),
        'condition'  => [
            'field_type' => ['utilities'],
            'utility_type' => ['elementor_template'],
        ],
    ]
);

// date format control
$repeater->add_control(
    'date_format',
    [
        'label'       => esc_html__('Date Format', 'gbx'),
        'type'        => \Elementor\Controls_Manager::TEXT,
        'default'     => 'F j, Y',
        'label_block' => false,
        'condition'  => [
            'field_type' => ['meta'],
            'meta_type' => ['date'],
        ],
    ]
);

// max no of authors control
$repeater->add_control(
    'max_no_of_authors',
    [
        'label'       => esc_html__('Max No of Authors to show', 'gbx'),
        'type'        => \Elementor\Controls_Manager::NUMBER,
        'default'     => 1,
        'label_block' => false,
        'condition'  => [
            'field_type' => ['meta'],
            'meta_type' => ['author'],
        ],
    ]
);

// author field
$repeater->add_control(
    'author_field',
    [
        'label'   => esc_html__('Author Field', 'gbx'),
        'type'    => \Elementor\Controls_Manager::SELECT,
        'default' => 'display_name',
        'options' => [
            'display_name' => esc_html__('Display Name', 'gbx'),
            'first_name'   => esc_html__('First Name', 'gbx'),
            'last_name'    => esc_html__('Last Name', 'gbx'),
            'user_login'   => esc_html__('User Login', 'gbx'),
        ],
        'condition'  => [
            'field_type' => ['meta'],
            'meta_type' => ['author'],
        ],
    ]
);

// date types control
$repeater->add_control(
    'date_type',
    [
        'label'   => esc_html__('Date Type', 'gbx'),
        'type'    => \Elementor\Controls_Manager::SELECT,
        'default' => 'post_date',
        'options' => [
            'post_date'      => esc_html__('Post Date', 'gbx'),
            'post_modified'  => esc_html__('Post Modified', 'gbx'),
        ],
        'condition'  => [
            'field_type' => ['meta'],
            'meta_type' => ['date'],
        ],
    ]
);


/*
    #NOTE : Taxonomies

    Taxonomy field is only available for meta field type

*/




// taxonomies control
$repeater->add_control(
    'taxonomies',
    [
        'label'       => esc_html__('Taxonomy', 'gbx'),
        'type'        => \Elementor\Controls_Manager::SELECT2,
        'default'     => 'category',
        'options'     => GRIDBUILDERX\Utils::get_list_of_all_taxonomies(),
        'label_block' => false,
        'condition'  => [
            'field_type' => ['meta'],
            'meta_type' => ['categories'],
        ],
        'frontend_available' => true,
    ]
);

// no of taxonomies control
$repeater->add_control(
    'no_of_taxonomies',
    [
        'label'       => esc_html__('No of Terms to show', 'gbx'),
        'type'        => \Elementor\Controls_Manager::NUMBER,
        'default'     => 1,
        'label_block' => false,
        'condition'  => [
            'field_type' => ['meta'],
            'meta_type' => ['categories'],
        ],
    ]
);

// enable link for terms
$repeater->add_control(
    'enable_link_terms',
    [
        'label'        => esc_html__('Enable Link for terms', 'gbx'),
        'type'         => \Elementor\Controls_Manager::SWITCHER,
        'label_on'     => esc_html__('Yes', 'gbx'),
        'label_off'    => esc_html__('No', 'gbx'),
        'return_value' => 'yes',
        'default'      => 'yes',
        'condition'  => [
            'field_type' => ['meta'],
            'meta_type' => ['categories'],
        ],
    ]
);


// open link in new tab
$repeater->add_control(
    'open_term_links_in_new_tab',
    [
        'label'        => esc_html__('Open Terms Link in New Tab', 'gbx'),
        'type'         => \Elementor\Controls_Manager::SWITCHER,
        'label_on'     => esc_html__('Yes', 'gbx'),
        'label_off'    => esc_html__('No', 'gbx'),
        'return_value' => 'yes',
        'default'      => 'yes',
        'condition'  => [
            'field_type' => ['meta'],
            'meta_type' => ['categories'],
            'enable_link_terms' => ['yes'],
        ],
    ]
);

// include only terms , comma separated
$repeater->add_control(
    'include_terms',
    [
        'label'       => esc_html__('Include Terms', 'gbx'),
        'type'        => \Elementor\Controls_Manager::TEXT,
        'default'     => '',
        'label_block' => false,
        'condition'  => [
            'field_type' => ['meta'],
            'meta_type' => ['categories'],
        ],
        'description' => 'Comma separated full term names, no space after comma. Example: "Term 1,Term 2,Term 3"',
    ]
);

// exclude terms , comma separated
$repeater->add_control(
    'exclude_terms',
    [
        'label'       => esc_html__('Exclude Terms', 'gbx'),
        'type'        => \Elementor\Controls_Manager::TEXT,
        'default'     => '',
        'label_block' => false,
        'condition'  => [
            'field_type' => ['meta'],
            'meta_type' => ['categories'],
        ],
        'description' => 'Comma separated full term names, no space after comma. Example: "Term 1,Term 2,Term 3"',
    ]
);

// separator control
$repeater->add_control(
    'separator',
    [
        'label'       => esc_html__('Separator', 'gbx'),
        'type'        => \Elementor\Controls_Manager::TEXT,
        'default'     => ', ',
        'label_block' => false,
        'condition'  => [
            'field_type' => ['meta'],
            'meta_type' => ['categories'],
        ],
    ]
);

// include hirearchical control
$repeater->add_control(
    'include_hierarchical',
    [
        'label'        => esc_html__('Include Hierarchical', 'gbx'),
        'type'         => \Elementor\Controls_Manager::SWITCHER,
        'label_on'     => esc_html__('Yes', 'gbx'),
        'label_off'    => esc_html__('No', 'gbx'),
        'return_value' => 'yes',
        'default'      => 'yes',
        'condition'  => [
            'field_type' => ['meta'],
            'meta_type' => ['categories', 'tags'],
        ],
    ]
);



// plain text control
$repeater->add_control(
    'plain_text',
    [
        'label'       => esc_html__('Plain Text', 'gbx'),
        'type'        => \Elementor\Controls_Manager::TEXT,
        'default'     => esc_html__('Plain Text', 'gbx'),
        'label_block' => false,
        'condition'  => [
            'field_type' => ['text'],
            'text_type' => ['plain_text'],
        ],
    ]
);

// custom field key control
$repeater->add_control(
    'custom_field_key',
    [
        'label'       => esc_html__('Custom Field Key', 'gbx'),
        'type'        => \Elementor\Controls_Manager::TEXT,
        'default'     => '',
        'label_block' => false,
        'condition'  => [
            'field_type' => ['text'],
            'text_type' => ['custom'],
        ],
    ]
);


// acf field key select control
$repeater->add_control(
    'acf_field_key',
    [
        'label'       => esc_html__('ACF Field Key', 'gbx'),
        'type'        => \Elementor\Controls_Manager::SELECT2,
        'default'     => '',
        'options'     => GRIDBUILDERX\Utils::get_list_of_all_acf_fields(),
        //condtion for button and text and image
        'condition'  => [
            'field_type' => ['text'],
            'text_type' => ['acf'],
        ],
    ]
);

// woocommerce field types
$repeater->add_control(
    'woocommerce_field_type',
    [
        'label'   => esc_html__('WooCommerce Field Type', 'gbx'),
        'type'    => \Elementor\Controls_Manager::SELECT,
        'default' => 'price',
        'options' => [
            'price'          => esc_html__('Price', 'gbx'),
            'sku'            => esc_html__('SKU', 'gbx'),
            'stock'          => esc_html__('Stock', 'gbx'),
            'rating'         => esc_html__('Rating', 'gbx'),
            'sale_price'     => esc_html__('Sale Price', 'gbx'),
            'regular_price'  => esc_html__('Regular Price', 'gbx'),
            'sale_percentage' => esc_html__('Sale Percentage', 'gbx'),
            'summary'        => esc_html__('Summary', 'gbx'),
            'description' => esc_html__('Description', 'gbx'),
        ],
        'condition'  => [
            'field_type' => ['text'],
            'text_type' => ['woocommerce'],
        ],
    ]
);

// star inacive color control
$repeater->add_control(
    'star_inactive_color',
    [
        'label'     => esc_html__('Star Inactive Color', 'gbx'),
        'type'      => \Elementor\Controls_Manager::COLOR,
        'default'   => '#e5e5e5',
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-star-rating .gbx-star' => 'color: {{VALUE}}',
        ],
        'condition'  => [
            'field_type' => ['text'],
            'text_type' => ['woocommerce'],
            'woocommerce_field_type' => ['rating'],
        ],
    ]
);


// star active color control
$repeater->add_control(
    'star_active_color',
    [
        'label'     => esc_html__('Star Active Color', 'gbx'),
        'type'      => \Elementor\Controls_Manager::COLOR,
        'default'   => '#ffd700',
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-star-rating .gbx-star.filled' => 'color: {{VALUE}}',
        ],
        'condition'  => [
            'field_type' => ['text'],
            'text_type' => ['woocommerce'],
            'woocommerce_field_type' => ['rating'],
        ],
    ]
);


// is inside a group?
$repeater->add_control(
    'is_inside_group',
    [
        'label'        => esc_html__('Is Inside Group?', 'gbx'),
        'type'         => \Elementor\Controls_Manager::SWITCHER,
        'label_on'     => esc_html__('Yes', 'gbx'),
        'label_off'    => esc_html__('No', 'gbx'),
        'return_value' => 'yes',
        'default'      => '',
        'condition'  => [
            'field_type' => ['text'],
            'text_type' => ['acf'],
        ],
    ]
);

// group field key text control
$repeater->add_control(
    'group_field_key',
    [
        'label'       => esc_html__('Group Field Key', 'gbx'),
        'type'        => \Elementor\Controls_Manager::TEXT,
        'default'     => '',
        'placeholder' => esc_html__('Group Field Key', 'gbx'),
        'condition'  => [
            'field_type' => ['text'],
            'text_type' => ['acf'],
            'is_inside_group' => ['yes'],
        ],
    ]
);

// enable image lightbox
$repeater->add_control(
    'enable_image_lightbox',
    [
        'label'        => esc_html__('Enable Image Lightbox?', 'gbx'),
        'type'         => \Elementor\Controls_Manager::SWITCHER,
        'label_on'     => esc_html__('Yes', 'gbx'),
        'label_off'    => esc_html__('No', 'gbx'),
        'return_value' => 'yes',
        'default'      => '',
        'condition'  => [
            'field_type' => ['image'],
        ],
    ]
);

// wrapper tag
$repeater->add_control(
    'wrapper_tag',
    [
        'label'   => esc_html__('Wrapper Tag', 'gbx'),
        'type'    => \Elementor\Controls_Manager::SELECT,
        'default' => 'div',
        'options' => [
            'div'          => esc_html__('div', 'gbx'),
            'span'         => esc_html__('span', 'gbx'),
            'p'            => esc_html__('p', 'gbx'),
            'h1'           => esc_html__('h1', 'gbx'),
            'h2'           => esc_html__('h2', 'gbx'),
            'h3'           => esc_html__('h3', 'gbx'),
            'h4'           => esc_html__('h4', 'gbx'),
            'h5'           => esc_html__('h5', 'gbx'),
            'h6'           => esc_html__('h6', 'gbx'),
        ],
    ]
);



// content specific controls

// button types
$repeater->add_control(
    'button_type',
    [
        'label'   => esc_html__('Button Type', 'gbx'),
        'type'    => \Elementor\Controls_Manager::SELECT,
        'default' => 'postlink',
        'options' => [
            'postlink'          => esc_html__('Link to post', 'gbx'),
            'acfurl'         => esc_html__('ACF URL', 'gbx'),
            'custom'            => esc_html__('Custom URL', 'gbx'),
            'addtocart'            => esc_html__('Add To Cart', 'gbx'),
        ],
        'condition'  => [
            'field_type' => ['button'],
        ],
    ]
);



// acf field key select control fror button
$repeater->add_control(
    'acf_field_key_button',
    [
        'label'       => esc_html__('ACF Field Key for Button Link', 'gbx'),
        'type'        => \Elementor\Controls_Manager::SELECT2,
        'default'     => '',
        'options'     => GRIDBUILDERX\Utils::get_list_of_all_acf_fields(),
        'condition'  => [
            'field_type' => ['button'],
            'button_type' => ['acfurl'],
        ],
    ]
);

// custom url control for button
$repeater->add_control(
    'custom_url',
    [
        'label'       => esc_html__('Custom URL', 'gbx'),
        'type'        => \Elementor\Controls_Manager::TEXT,
        'default'     => '',
        'placeholder' => esc_html__('Custom URL', 'gbx'),
        'condition'  => [
            'field_type' => ['button'],
            'button_type' => ['custom'],
        ],
    ]
);

// button text control
$repeater->add_control(
    'button_text',
    [
        'label'       => esc_html__('Button Text', 'gbx'),
        'type'        => \Elementor\Controls_Manager::TEXT,
        'default'     => esc_html__('Read More', 'gbx'),
        'placeholder' => esc_html__('Read More', 'gbx'),
        'condition'  => [
            'field_type' => ['button'],
            'button_type' => ['postlink', 'acfurl', 'custom'],
        ],
    ]
);

// open in new tab
$repeater->add_control(
    'open_in_new_tab',
    [
        'label'        => esc_html__('Open in New Tab', 'gbx'),
        'type'         => \Elementor\Controls_Manager::SWITCHER,
        'label_on'     => esc_html__('Yes', 'gbx'),
        'label_off'    => esc_html__('No', 'gbx'),
        'return_value' => 'yes',
        'default'      => 'no',
        'condition'  => [
            'field_type' => ['button'],
            'button_type' => ['postlink', 'acfurl', 'custom'],
        ],
    ]
);


// enable excert?
$repeater->add_control(
    'enable_excerpt_trim',
    [
        'label'        => esc_html__('Enable Triming?', 'gbx'),
        'type'         => \Elementor\Controls_Manager::SWITCHER,
        'label_on'     => esc_html__('Yes', 'gbx'),
        'label_off'    => esc_html__('No', 'gbx'),
        'return_value' => 'yes',
        'default'      => 'no',
        'condition'  => [
            'field_type' => ['text'],
            'text_type' => ['excerpt', 'title', 'content', 'acf', 'custom', 'woocommerce'],
        ],
    ]
);

// is rating?
$repeater->add_control(
    'is_rating',
    [
        'label'        => esc_html__('Is Rating?', 'gbx'),
        'type'         => \Elementor\Controls_Manager::SWITCHER,
        'label_on'     => esc_html__('Yes', 'gbx'),
        'label_off'    => esc_html__('No', 'gbx'),
        'return_value' => 'yes',
        'default'      => 'no',
        'condition'  => [
            'field_type' => ['text'],
        ],
    ]
);

// rating icons control
$repeater->add_control(
    'rating_icons',
    [
        'label'       => esc_html__('Rating Icons', 'gbx'),
        'type'        => \Elementor\Controls_Manager::ICONS,
        'default'     => [
            'value'   => 'fas fa-star',
            'library' => 'solid',
        ],
        'condition'  => [
            'field_type' => ['text'],
            'is_rating' => ['yes'],
        ],
    ]
);

// rating icons color
$repeater->add_control(
    'rating_icons_color',
    [
        'label'     => esc_html__('Rating Icons Color', 'gbx'),
        'type'      => \Elementor\Controls_Manager::COLOR,
        'default'   => '#ffcc00',
        'condition'  => [
            'field_type' => ['text'],
            'is_rating' => ['yes'],
        ],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} i' => 'color: {{VALUE}}',
            '{{WRAPPER}} {{CURRENT_ITEM}} SVG' => 'fill: {{VALUE}}',
        ],
    ]
);

// rating icons size
$repeater->add_responsive_control(
    'rating_icons_size',
    [
        'label'      => esc_html__('Rating Icons Size', 'gbx'),
        'type'       => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['px', 'em', '%'],
        'range'      => [
            'px' => [
                'min' => 0,
                'max' => 100,
            ],
        ],
        'default'    => [
            'unit' => 'px',
            'size' => 15,
        ],
        'condition'  => [
            'field_type' => ['text'],
            'is_rating' => ['yes'],
        ],
        'selectors'  => [
            '{{WRAPPER}} {{CURRENT_ITEM}} i' => 'font-size: {{SIZE}}{{UNIT}};',
            '{{WRAPPER}} {{CURRENT_ITEM}} SVG' => 'width: {{SIZE}}{{UNIT}}; height: {{SIZE}}{{UNIT}};',
        ],
    ]
);




// excerpt length
$repeater->add_control(
    'excerpt_length',
    [
        'label'     => esc_html__('Excerpt Length', 'gbx'),
        'type'      => \Elementor\Controls_Manager::NUMBER,
        'default'   => 20,
        'condition'  => [
            'field_type' => ['text'],
            'text_type' => ['excerpt', 'title', 'content', 'acf', 'custom', 'woocommerce'],
            'enable_excerpt_trim' => ['yes'],
        ],
    ]
);

// prefix type
$repeater->add_control(
    'prefix_type',
    [
        'label'   => esc_html__('Prefix Type', 'gbx'),
        'type'    => \Elementor\Controls_Manager::SELECT,
        'default' => 'none',
        'options' => [
            'none'          => esc_html__('None', 'gbx'),
            'text'          => esc_html__('Text', 'gbx'),
            'icon'          => esc_html__('Icon', 'gbx'),
            'html'          => esc_html__('HTML', 'gbx'),
        ],
        'condition'  => [
            'field_type' => ['text', 'button', 'meta'],
            'text_type' => ['title', 'content', 'excerpt', 'acf', 'woocommerce', 'custom', 'plain_text', 'button'],
            'button_type' => ['postlink', 'acfurl', 'custom'],
        ],
    ]
);

// prefix text
$repeater->add_control(
    'prefix_text',
    [
        'label'       => esc_html__('Prefix Text', 'gbx'),
        'type'        => \Elementor\Controls_Manager::TEXT,
        'default'     => '',
        'placeholder' => esc_html__('Enter prefix text', 'gbx'),
        'condition'  => [
            'field_type' => ['text', 'meta'],
            'text_type' => ['title', 'content', 'excerpt', 'acf', 'woocommerce', 'custom'],
            'prefix_type' => ['text'],
        ],
    ]
);

// prefix icon
$repeater->add_control(
    'prefix_icon',
    [
        'label'     => esc_html__('Prefix Icon', 'gbx'),
        'type'      => \Elementor\Controls_Manager::ICONS,
        'default'   => [
            'value'   => 'far fa-check-circle',
            'library' => 'fa-regular',
        ],
        'condition'  => [
            'field_type' => ['text', 'button', 'meta'],
            'text_type' => ['title', 'content', 'excerpt', 'acf', 'woocommerce', 'custom', 'plain_text', 'button'],
            'prefix_type' => ['icon'],
        ],
    ]
);
// prefix icon color
$repeater->add_control(
    'prefix_icon_color',
    [
        'label'     => esc_html__('Prefix Icon Color', 'gbx'),
        'type'      => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-prefix-icon' => 'color: {{VALUE}};',
            '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-prefix-icon svg' => 'fill: {{VALUE}};',
        ],
        'condition'  => [
            'field_type' => ['text', 'button', 'meta'],
            'text_type' => ['title', 'content', 'excerpt', 'acf', 'woocommerce', 'custom', 'plain_text', 'button'],
            'prefix_type' => ['icon'],
        ],
    ]
);


// prefix icon size
$repeater->add_responsive_control(
    'prefix_icon_size',
    [
        'label'      => esc_html__('Prefix Icon Size', 'gbx'),
        'type'       => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['px', 'em', 'rem'],
        'range'      => [
            'px' => [
                'min' => 0,
                'max' => 100,
            ],
        ],
        'selectors'  => [
            '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-repeater-item-inner .gbx-prefix-icon' => 'font-size: {{SIZE}}{{UNIT}};',
            '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-repeater-item-inner .gbx-prefix-icon' => 'width: {{SIZE}}{{UNIT}};',
            '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-repeater-item-inner .gbx-prefix-icon svg' => 'width: {{SIZE}}{{UNIT}};',
        ],
        'condition'  => [
            'field_type' => ['text', 'button', 'meta'],
            'text_type' => ['title', 'content', 'excerpt', 'acf', 'woocommerce', 'custom', 'plain_text', 'button'],
            'prefix_type' => ['icon'],
        ],
    ]
);

// icon margin
$repeater->add_responsive_control(
    'prefix_icon_margin',
    [
        'label'      => esc_html__('Icon Spacing', 'gbx'),
        'type'       => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', 'rem'],
        'selectors'  => [
            '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-repeater-item-inner .gbx-prefix-icon svg' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
            '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-repeater-item-inner .gbx-prefix-icon i' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition'  => [
            'field_type' => ['text', 'button', 'meta'],
            'text_type' => ['title', 'content', 'excerpt', 'acf', 'woocommerce', 'custom', 'plain_text', 'button'],
            'prefix_type' => ['icon'],
        ],
    ]
);


// code control for prefix html
$repeater->add_control(
    'prefix_html',
    [
        'label'       => esc_html__('Prefix HTML', 'gbx'),
        'type'        => \Elementor\Controls_Manager::CODE,
        'language'    => 'html',
        'rows'        => 10,
        'placeholder' => esc_html__('Enter prefix html', 'gbx'),
        'condition'  => [
            'field_type' => ['text', 'button', 'meta'],
            'text_type' => ['title', 'content', 'excerpt', 'acf', 'woocommerce', 'custom', 'plain_text'],
            'prefix_type' => ['html'],
        ],
    ]
);

// suffix type
$repeater->add_control(
    'suffix_type',
    [
        'label'   => esc_html__('Suffix Type', 'gbx'),
        'type'    => \Elementor\Controls_Manager::SELECT,
        'default' => 'none',
        'options' => [
            'none'          => esc_html__('None', 'gbx'),
            'text'          => esc_html__('Text', 'gbx'),
            'icon'          => esc_html__('Icon', 'gbx'),
            'html'          => esc_html__('HTML', 'gbx'),
        ],
        'condition'  => [
            'field_type' => ['text', 'button', 'meta'],
            'text_type' => ['title', 'content', 'excerpt', 'acf', 'woocommerce', 'custom', 'plain_text', 'button'],
            'button_type!' => ['addtocart'],
        ],
    ]
);

// suffix text
$repeater->add_control(
    'suffix_text',
    [
        'label'       => esc_html__('Suffix Text', 'gbx'),
        'type'        => \Elementor\Controls_Manager::TEXT,
        'default'     => '',
        'placeholder' => esc_html__('Enter suffix text', 'gbx'),
        'condition'  => [
            'field_type' => ['text', 'button', 'meta'],
            'text_type' => ['title', 'content', 'excerpt', 'acf', 'woocommerce', 'custom', 'plain_text', 'button'],
            'suffix_type' => ['text'],
        ],
    ]
);

// suffix icon
$repeater->add_control(
    'suffix_icon',
    [
        'label'     => esc_html__('Suffix Icon', 'gbx'),
        'type'      => \Elementor\Controls_Manager::ICONS,
        'default'   => [
            'value'   => 'far fa-check-circle',
            'library' => 'fa-regular',
        ],
        'condition'  => [
            'field_type' => ['text', 'button', 'meta'],
            'text_type' => ['title', 'content', 'excerpt', 'acf', 'woocommerce', 'custom', 'plain_text', 'button'],
            'suffix_type' => ['icon'],
        ],
    ]
);




// icon color
$repeater->add_control(
    'icon_color_suffix',
    [
        'label'     => esc_html__('Icon Color', 'gbx'),
        'type'      => \Elementor\Controls_Manager::COLOR,
        'default'   => '',
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-repeater-item-inner .gbx-suffix-icon' => 'color: {{VALUE}}',
            '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-repeater-item-inner .gbx-suffix-icon  svg' => 'fill: {{VALUE}}',
        ],
        'condition'  => [
            'field_type' => ['text', 'button', 'meta'],
            'text_type' => ['title', 'content', 'excerpt', 'acf', 'woocommerce', 'custom', 'plain_text', 'button'],
            'suffix_type' => ['icon'],
        ],

    ]
);

// icon size
$repeater->add_control(
    'icon_size_suffix',
    [
        'label'     => esc_html__('Icon Size', 'gbx', 'meta'),
        'type'      => \Elementor\Controls_Manager::SLIDER,
        'default'   => [
            'size' => 16,
        ],
        'range'     => [
            'px' => [
                'min' => 10,
                'max' => 100,
            ],
        ],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-repeater-item-inner .gbx-suffix-icon' => 'font-size: {{SIZE}}{{UNIT}}',
            '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-repeater-item-inner .gbx-suffix-icon' => 'width: {{SIZE}}{{UNIT}};',
            '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-repeater-item-inner .gbx-suffix-icon svg' => 'width: {{SIZE}}{{UNIT}};',
        ],
        'condition'  => [
            'field_type' => ['text', 'button', 'meta'],
            'text_type' => ['title', 'content', 'excerpt', 'acf', 'woocommerce', 'custom', 'plain_text', 'button'],
            'suffix_type' => ['icon'],
        ],
    ]
);

// suffix icon margin
$repeater->add_responsive_control(
    'suffix_icon_margin',
    [
        'label'      => esc_html__('Icon Spacing', 'gbx'),
        'type'       => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', 'rem'],
        'selectors'  => [
            '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-repeater-item-inner .gbx-suffix-icon svg' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
            '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-repeater-item-inner .gbx-suffix-icon i' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition'  => [
            'field_type' => ['text', 'button', 'meta'],
            'text_type' => ['title', 'content', 'excerpt', 'acf', 'woocommerce', 'custom', 'plain_text', 'button'],
            'suffix_type' => ['icon'],
        ],
    ]
);

// code control for suffix html
$repeater->add_control(
    'suffix_html',
    [
        'label'       => esc_html__('Suffix HTML', 'gbx'),
        'type'        => \Elementor\Controls_Manager::CODE,
        'language'    => 'html',
        'rows'        => 10,
        'placeholder' => esc_html__('Enter suffix html', 'gbx'),
        'condition'  => [
            'field_type' => ['text', 'button', 'meta'],
            'text_type' => ['title', 'content', 'excerpt', 'acf', 'woocommerce', 'custom', 'plain_text'],
            'suffix_type' => ['html'],
        ],
    ]
);

// placeholder
$repeater->add_control(
    'placeholder',
    [
        'label'       => esc_html__('Placeholder', 'gbx'),
        'type'        => \Elementor\Controls_Manager::TEXT,
        'default'     => '',
        'placeholder' => esc_html__('Enter placeholder', 'gbx'),
        'description' => esc_html__('This will be used as placeholder if field is empty', 'gbx'),
        'condition'  => [
            'field_type' => ['text', 'meta'],
            'text_type' => ['title', 'content', 'excerpt', 'acf', 'woocommerce', 'custom'],
        ],
    ]
);


// placeholder image
$repeater->add_control(
    'grid_image',
    [
        'label'     => esc_html__('Placeholder Image', 'gbx'),
        'type'      => \Elementor\Controls_Manager::MEDIA,
        'default'   => [
            'url' => \Elementor\Utils::get_placeholder_image_src(),
        ],
        'condition'  => [
            'field_type' => ['image'],
        ],
    ]
);

// placeholder image  size group control
$repeater->add_group_control(
    \Elementor\Group_Control_Image_Size::get_type(),
    [
        'name'      => 'grid_image',
        'default'   => 'large',
        'separator' => 'none',
        'condition'  => [
            'field_type' => ['image'],
        ],
    ]
);

// width
$repeater->add_responsive_control(
    'width',
    [
        'label'      => esc_html__('Wrapper Width', 'gbx'),
        'type'       => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['px', 'em', 'rem', '%'],
        'range'      => [
            'px' => [
                'min' => 0,
                'max' => 1000,
            ],
        ],
        'default'    => [
            'unit' => '%',
            'size' => 100,
        ],
        'selectors'  => [
            '{{WRAPPER}} {{CURRENT_ITEM}}' => 'width: {{SIZE}}{{UNIT}};',
        ],
        'description' => esc_html__('This is the width of wrapper, not the grid element. Setting a width of 50% for two grid elements will put them in one line', 'gbx'),
    ]
);

// Width of inner content
$repeater->add_responsive_control(
    'inner_width',
    [
        'label'      => esc_html__('Grid Item Width', 'gbx'),
        'type'       => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['px', 'em', 'rem', '%'],
        'range'      => [
            'px' => [
                'min' => 0,
                'max' => 1000,
            ],
        ],
        'default'    => [
            'unit' => '%',
            'size' => 100,
        ],
        'selectors'  => [
            '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-repeater-item-inner' => 'width: {{SIZE}}{{UNIT}};',
        ],
        'description' => esc_html__('Width of grid item within inside the wrapper', 'gbx'),
    ]
);



// schema property
$repeater->add_control(
    'schema_property',
    [
        'label'       => esc_html__('Schema Property', 'gbx'),
        'type'        => \Elementor\Controls_Manager::SELECT,
        'default'     => 'none',
        'options'     => [
            '' => esc_html__('None', 'gbx'),
            'name' => esc_html__('Name', 'gbx'),
            'description' => esc_html__('Description', 'gbx'),
            'image' => esc_html__('Image', 'gbx'),
            'url' => esc_html__('URL', 'gbx'),
            'price' => esc_html__('Price', 'gbx'),
            'ratingValue' => esc_html__('ratingValue', 'gbx'),
            'other' => esc_html__('Other', 'gbx'),
        ],
        'condition'  => [
            'field_type' => ['text', 'image', 'button', 'meta'],
        ],
        'description' => esc_html__('Will only be available if schema is enabled', 'gbx'),
    ]
);

// other schema property
$repeater->add_control(
    'other_schema_property',
    [
        'label'       => esc_html__('Other Schema Property', 'gbx'),
        'type'        => \Elementor\Controls_Manager::TEXT,
        'default'     => '',
        'placeholder' => esc_html__('Enter other schema property', 'gbx'),
        'condition'  => [
            'field_type' => ['text', 'image', 'button', 'meta'],
            'schema_property' => ['other'],
        ],
    ]
);

// @type
$repeater->add_control(
    'type_schema_property',
    [
        'label'       => esc_html__('@type', 'gbx'),
        'type'        => \Elementor\Controls_Manager::TEXT,
        'default'     => '',
        'placeholder' => esc_html__('Enter @type', 'gbx'),
        'condition'  => [
            'field_type' => ['text', 'image', 'button', 'meta'],
            'schema_property' => ['other'],
        ],
    ]
);
