<?php

if (!defined('ABSPATH')) {
    exit; // Exit if accessed directly.
}


//headline control 
$repeater->add_control(
    'headline_images_st_button',
    [
        'label' => esc_html__('Button Specific Settings', 'gbx'),
        'type' => \Elementor\Controls_Manager::HEADING,
        'separator' => 'after',
        'condition' => [
            'field_type' => ['button'],
        ],
    ]
);

// button typography
$repeater->add_group_control(
    \Elementor\Group_Control_Typography::get_type(),
    [
        'name'     => 'gbx_repeater_button_typography',
        'label'    => esc_html__('Typography', 'gbx'),
        'selector' => '{{WRAPPER}} {{CURRENT_ITEM}} a',
        'condition' => [
            'field_type' => ['button'],
        ],
    ]
);


// button color 
$repeater->add_control(
    'gbx_repeater_button_color',
    [
        'label' => esc_html__('Button Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} a' => 'color: {{VALUE}};',
        ],
        'condition' => [
            'field_type' => ['button'],
        ],
    ]
);

// button background color with gradient and normal
$repeater->add_group_control(
    \Elementor\Group_Control_Background::get_type(),
    [
        'name' => 'gbx_repeater_button_background',
        'label' => esc_html__('Background', 'gbx'),
        'types' => ['classic', 'gradient'],
        'selector' => '{{WRAPPER}} {{CURRENT_ITEM}} a',
        'condition' => [
            'field_type' => ['button'],
        ],
    ]
);

// button border radius
$repeater->add_responsive_control(
    'gbx_repeater_button_border_radius',
    [
        'label' => esc_html__('Border Radius', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} a' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'field_type' => ['button'],
        ],
    ]
);

// button border width
$repeater->add_responsive_control(
    'gbx_repeater_button_border_width',
    [
        'label' => esc_html__('Border Width', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} a' => 'border-width: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'field_type' => ['button'],
        ],
    ]
);

// button border color
$repeater->add_control(
    'gbx_repeater_button_border_color',
    [
        'label' => esc_html__('Border Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} a' => 'border-color: {{VALUE}};',
        ],
        'condition' => [
            'field_type' => ['button'],
        ],
    ]
);

// button border style
$repeater->add_control(
    'gbx_repeater_button_border_style',
    [
        'label' => esc_html__('Border Style', 'gbx'),
        'type' => \Elementor\Controls_Manager::SELECT,
        'default' => 'solid',
        'options' => [
            'solid' => esc_html__('Solid', 'gbx'),
            'dashed' => esc_html__('Dashed', 'gbx'),
            'dotted' => esc_html__('Dotted', 'gbx'),
            'double' => esc_html__('Double', 'gbx'),
            'none' => esc_html__('None', 'gbx'),
        ],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} a' => 'border-style: {{VALUE}};',
        ],
        'condition' => [
            'field_type' => ['button'],
        ],
    ]
);


// button shadow
$repeater->add_group_control(
    \Elementor\Group_Control_Box_Shadow::get_type(),
    [
        'name' => 'gbx_repeater_button_shadow',
        'label' => esc_html__('Shadow', 'gbx'),
        'selector' => '{{WRAPPER}} {{CURRENT_ITEM}} a',
        'condition' => [
            'field_type' => ['button'],
        ],
    ]
);

// button text shadow
$repeater->add_group_control(
    \Elementor\Group_Control_Text_Shadow::get_type(),
    [
        'name' => 'gbx_repeater_button_text_shadow',
        'label' => esc_html__('Text Shadow', 'gbx'),
        'selector' => '{{WRAPPER}} {{CURRENT_ITEM}} a',
        'condition' => [
            'field_type' => ['button'],
        ],
    ]
);

// button padding
$repeater->add_responsive_control(
    'gbx_repeater_button_padding',
    [
        'label' => esc_html__('Padding', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} a' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'field_type' => ['button'],
        ],
    ]
);

// button margin
$repeater->add_responsive_control(
    'gbx_repeater_button_margin',
    [
        'label' => esc_html__('Margin', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} a' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'field_type' => ['button'],
        ],
    ]
);

// button text align use justify-content flex
$repeater->add_responsive_control(
    'gbx_repeater_button_text_align',
    [
        'label' => esc_html__('Text Align', 'gbx'),
        'type' => \Elementor\Controls_Manager::CHOOSE,
        'options' => [
            'left' => [
                'title' => esc_html__('Left', 'gbx'),
                'icon' => 'fa fa-align-left',
            ],
            'center' => [
                'title' => esc_html__('Center', 'gbx'),
                'icon' => 'fa fa-align-center',
            ],
            'right' => [
                'title' => esc_html__('Right', 'gbx'),
                'icon' => 'fa fa-align-right',
            ],
            'justify' => [
                'title' => esc_html__('Justify', 'gbx'),
                'icon' => 'fa fa-align-justify',
            ],
        ],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} a' => 'justify-content: {{VALUE}};',
        ],
        'condition' => [
            'field_type' => ['button'],
        ],
    ]
);

// button width
$repeater->add_responsive_control(
    'gbx_repeater_button_width',
    [
        'label' => esc_html__('Width', 'gbx'),
        'type' => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['px', '%', 'em'],
        'range' => [
            'px' => [
                'min' => 0,
                'max' => 1000,
                'step' => 1,
            ],
            '%' => [
                'min' => 0,
                'max' => 100,
                'step' => 1,
            ],
            'em' => [
                'min' => 0,
                'max' => 100,
                'step' => 1,
            ],
        ],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} a' => 'width: {{SIZE}}{{UNIT}};',
        ],
        'condition' => [
            'field_type' => ['button'],
        ],
    ]
);



//imgsa


/******************************* 
 * Image Specific Settings
 * @since 1.0.0
 ********************************/



$repeater->add_control(
    'headline_images_st',
    [
        'label' => esc_html__('Image Overlay', 'gbx'),
        'type' => \Elementor\Controls_Manager::HEADING,
        'separator' => 'after',
        'condition' => [
            'field_type' => ['image'],
        ],
    ]
);

// image overlay  background group control
$repeater->add_group_control(
    \Elementor\Group_Control_Background::get_type(),
    [
        'name' => 'gbx_repeater_image_overlay',
        'label' => esc_html__('Overlay', 'gbx'),
        'types' => ['classic', 'gradient'],
        'selector' => '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-overlay-image',
        'condition' => [
            'field_type' => ['image'],
        ],
    ]
);


// opacity
$repeater->add_control(
    'gbx_repeater_image_opacity',
    [
        'label' => esc_html__('Overlay Opacity', 'gbx'),
        'type' => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['%'],
        'range' => [
            '%' => [
                'min' => 0,
                'max' => 1,
                'step' => 0.1,
            ],
        ],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-overlay-image' => 'opacity: {{SIZE}};',
        ],
        'condition' => [
            'field_type' => ['image'],
        ],
    ]
);




// // image width
$repeater->add_responsive_control(
    'gbx_repeater_image_width',
    [
        'label' => esc_html__('Image Width', 'gbx'),
        'type' => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['px', '%', 'em'],
        'range' => [
            'px' => [
                'min' => 0,
                'max' => 1000,
                'step' => 1,
            ],
            '%' => [
                'min' => 0,
                'max' => 100,
            ],
            'em' => [
                'min' => 0,
                'max' => 100,
            ],
        ],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} img' => 'width: {{SIZE}}{{UNIT}};',
        ],
        'condition' => [
            'field_type' => ['image'],
        ],
    ]
);


//Headline
$repeater->add_control(
    'headline_images_st_border',
    [
        'label' => esc_html__('Image Border', 'gbx'),
        'type' => \Elementor\Controls_Manager::HEADING,
        'separator' => 'after',
        'condition' => [
            'field_type' => ['image'],
        ],
    ]
);

//image border control
$repeater->add_group_control(
    \Elementor\Group_Control_Border::get_type(),
    [
        'name' => 'gbx_repeater_image_border',
        'label' => esc_html__('Border', 'gbx'),
        'selector' => '{{WRAPPER}} {{CURRENT_ITEM}} img',
        'condition' => [
            'field_type' => ['image'],
        ],
    ]
);


//headline


// image border radius
$repeater->add_responsive_control(
    'gbx_repeater_image_border_radius',
    [
        'label' => esc_html__('Image Border Radius', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} img' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'field_type' => ['image'],
        ],
    ]
);

// image shadow
$repeater->add_group_control(
    \Elementor\Group_Control_Box_Shadow::get_type(),
    [
        'name' => 'gbx_repeater_image_shadow',
        'label' => esc_html__('Image Shadow', 'gbx'),
        'selector' => '{{WRAPPER}} {{CURRENT_ITEM}} img',
        'condition' => [
            'field_type' => ['image'],
        ],
    ]
);

// image horizontal alignment
$repeater->add_responsive_control(
    'gbx_repeater_image_horizontal_alignment',
    [
        'label' => esc_html__('Horizontal Alignment', 'gbx'),
        'type' => \Elementor\Controls_Manager::CHOOSE,
        'options' => [
            'left' => [
                'title' => esc_html__('Left', 'gbx'),
                'icon' => 'fa fa-align-left',
            ],
            'center' => [
                'title' => esc_html__('Center', 'gbx'),
                'icon' => 'fa fa-align-center',
            ],
            'right' => [
                'title' => esc_html__('Right', 'gbx'),
                'icon' => 'fa fa-align-right',
            ],
        ],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}}' => 'text-align: {{VALUE}};',
        ],
        'condition' => [
            'field_type' => ['image'],
        ],
    ]
);



// utilities , divider specific controls


// color
$repeater->add_control(
    'gbx_repeater_color',
    [
        'label'     => esc_html__('Color', 'gbx'),
        'type'      => \Elementor\Controls_Manager::COLOR,
        'default'   => '#54595f',
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} hr' => 'background-color: {{VALUE}};',
        ],
        'condition'  => [
            'field_type' => ['utilities'],
            'utility_type' => ['divider'],
        ],
    ]
);

// width
$repeater->add_responsive_control(
    'gbx_repeater_width',
    [
        'label' => esc_html__('Width of Divider', 'gbx'),
        'type' => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['px', '%', 'em'],
        'range' => [
            'px' => [
                'min' => 0,
                'max' => 1000,
            ],
            '%' => [
                'min' => 0,
                'max' => 100,
            ],
            'em' => [
                'min' => 0,
                'max' => 100,
            ],
        ],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} hr' => 'width: {{SIZE}}{{UNIT}};',
        ],
        'condition'  => [
            'field_type' => ['utilities'],
            'utility_type' => ['divider'],
        ],
    ]
);

// height
$repeater->add_responsive_control(
    'gbx_repeater_height',
    [
        'label' => esc_html__('Height of Divider', 'gbx'),
        'type' => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['px', '%', 'em'],
        'range' => [
            'px' => [
                'min' => 0,
                'max' => 1000,
            ],
            '%' => [
                'min' => 0,
                'max' => 100,
            ],
            'em' => [
                'min' => 0,
                'max' => 100,
            ],
        ],
        'default' => [
            'unit' => 'px',
            'size' => 5,
        ],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} hr' => 'height: {{SIZE}}{{UNIT}};',
        ],
        'condition'  => [
            'field_type' => ['utilities'],
            'utility_type' => ['divider'],
        ],
    ]
);

//border for divider
$repeater->add_group_control(
    \Elementor\Group_Control_Border::get_type(),
    [
        'name' => 'gbx_repeater_border_main',
        'label' => esc_html__('Border', 'gbx'),
        'selector' => '{{WRAPPER}} {{CURRENT_ITEM}} hr',
        'condition'  => [
            'field_type' => ['utilities'],
            'utility_type' => ['divider'],
        ],
    ]
);



// icons in utilities

// icon color
$repeater->add_control(
    'gbx_repeater_icon_color',
    [
        'label'     => esc_html__('Icon Color', 'gbx'),
        'type'      => \Elementor\Controls_Manager::COLOR,
        'default'   => '#54595f',
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} i' => 'color: {{VALUE}};',
            '{{WRAPPER}} {{CURRENT_ITEM}} svg' => 'fill: {{VALUE}};',
        ],
        'condition'  => [
            'field_type' => ['utilities'],
            'utility_type' => ['icon'],
        ],
    ]
);

//icon width
$repeater->add_responsive_control(
    'gbx_repeater_icon_width',
    [
        'label' => esc_html__('Icon Width', 'gbx'),
        'type' => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['px', '%', 'em'],
        'range' => [
            'px' => [
                'min' => 0,
                'max' => 1000,
            ],
            '%' => [
                'min' => 0,
                'max' => 100,
            ],
            'em' => [
                'min' => 0,
                'max' => 100,
            ],
        ],
        'default' => [
            'unit' => 'px',
            'size' => 20,
        ],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} i' => 'font-size: {{SIZE}}{{UNIT}};',
            '{{WRAPPER}} {{CURRENT_ITEM}} svg' => 'width: {{SIZE}}{{UNIT}};',
        ],
        'condition'  => [
            'field_type' => ['utilities'],
            'utility_type' => ['icon'],
        ],
    ]
);



// font control
$repeater->add_group_control(
    \Elementor\Group_Control_Typography::get_type(),
    [
        'name'     => 'gbx_repeater_typography',
        'label'    => esc_html__('Typography', 'gbx'),
        'selector' => '{{WRAPPER}} {{CURRENT_ITEM}}',
        'condition'  => [
            'field_type' => ['text', 'shortcode', 'meta'],
        ],
    ]
);




$repeater->add_control(
    'gbx_repeater_color_main',
    [
        'label'     => esc_html__('Color', 'gbx'),
        'type'      => \Elementor\Controls_Manager::COLOR,
        'default'   => '#54595f',
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}}' => 'color: {{VALUE}}',
        ],
        'condition'  => [
            'field_type' => ['text', 'button', 'meta'],
        ],
    ]
);

// if link then color
$repeater->add_control(
    'gbx_repeater_color_link_meta',
    [
        'label'     => esc_html__('Color of meta terms', 'gbx'),
        'type'      => \Elementor\Controls_Manager::COLOR,
        'default'   => '#54595f',
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} a' => 'color: {{VALUE}}',
        ],
        'condition'  => [
            'field_type' => ['meta'],
            'meta_type' => ['categories'],
        ],
    ]
);

// background color of links
$repeater->add_control(
    'gbx_repeater_color_link_bg_meta',
    [
        'label'     => esc_html__('Background Color for terms', 'gbx'),
        'type'      => \Elementor\Controls_Manager::COLOR,
        'default'   => '#fff',
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} a' => 'background-color: {{VALUE}}',
        ],
        'condition'  => [
            'field_type' => ['meta'],
            'meta_type' => ['categories'],
        ],
    ]
);

// padding for links
$repeater->add_responsive_control(
    'gbx_repeater_padding_link_meta',
    [
        'label' => esc_html__('Padding for terms', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'default' => [
            'top' => 5,
            'right' => 10,
            'bottom' => 5,
            'left' => 10,
            'isLinked' => false,
        ],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} a' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition'  => [
            'field_type' => ['meta'],
            'meta_type' => ['categories'],
        ],
    ]
);

// margin for links dimensions control
$repeater->add_responsive_control(
    'gbx_repeater_margin_link_meta',
    [
        'label' => esc_html__('Margin for terms', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'default' => [
            'top' => 0,
            'right' => 10,
            'bottom' => 0,
            'left' => 0,
            'isLinked' => false,
        ],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} a' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition'  => [
            'field_type' => ['meta'],
            'meta_type' => ['categories'],
        ],
    ]
);



// border radius control for links group control
$repeater->add_group_control(
    \Elementor\Group_Control_Border::get_type(),
    [
        'name' => 'gbx_repeater_border_link_meta',
        'label' => esc_html__('Border for terms', 'gbx'),
        'selector' => '{{WRAPPER}} {{CURRENT_ITEM}} a',
        'condition'  => [
            'field_type' => ['meta'],
            'meta_type' => ['categories'],
        ],
    ]
);

// border radius control for links dimensions control
$repeater->add_responsive_control(
    'gbx_repeater_border_radius_link_meta',
    [
        'label' => esc_html__('Border Radius for terms', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'default' => [
            'top' => 0,
            'right' => 0,
            'bottom' => 0,
            'left' => 0,
            'isLinked' => false,
        ],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} a' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition'  => [
            'field_type' => ['meta'],
            'meta_type' => ['categories'],
        ],
    ]
);

//heading - Container Background
$repeater->add_control(
    'gbx_repeater_heading_container_background_hc',
    [
        'label'     => esc_html__('Wrapper Background', 'gbx'),
        'type'      => \Elementor\Controls_Manager::HEADING,
    ]
);

// background image, color, gradient
$repeater->add_group_control(
    \Elementor\Group_Control_Background::get_type(),
    [
        'name'     => 'gbx_repeater_background_container',
        'label'    => esc_html__('Constainer Background', 'gbx'),
        'types'    => ['classic', 'gradient'],
        'selector' => '{{WRAPPER}} {{CURRENT_ITEM}}',
    ]
);


//heading - Container Background
$repeater->add_control(
    'gbx_repeater_heading_container_background_bc',
    [
        'label'     => esc_html__('Grid Element Background', 'gbx'),
        'type'      => \Elementor\Controls_Manager::HEADING,
    ]
);


// background image, color, gradient
$repeater->add_group_control(
    \Elementor\Group_Control_Background::get_type(),
    [
        'name'     => 'gbx_repeater_background',
        'label'    => esc_html__('Background', 'gbx'),
        'types'    => ['classic', 'gradient'],
        'selector' => '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-repeater-item-inner',
    ]
);




//text align
$repeater->add_responsive_control(
    'gbx_repeater_text_align',
    [
        'label'     => esc_html__('Text Align', 'gbx'),
        'type'      => \Elementor\Controls_Manager::CHOOSE,
        'options'   => [
            'left'    => [
                'title' => esc_html__('Left', 'gbx'),
                'icon'  => 'fa fa-align-left',
            ],
            'center'  => [
                'title' => esc_html__('Center', 'gbx'),
                'icon'  => 'fa fa-align-center',
            ],
            'right'   => [
                'title' => esc_html__('Right', 'gbx'),
                'icon'  => 'fa fa-align-right',
            ],
            'justify' => [
                'title' => esc_html__('Justified', 'gbx'),
                'icon'  => 'fa fa-align-justify',
            ],
        ],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}}' => 'text-align: {{VALUE}};',
        ],
        'condition'  => [
            'field_type' => ['text', 'button'],
        ],
    ]
);



// vertical align
$repeater->add_responsive_control(
    'gbx_repeater_vertical_align',
    [
        'label' => esc_html__('Vertical Align', 'gbx'),
        'type' => \Elementor\Controls_Manager::CHOOSE,
        'options' => [
            'flex-start' => [
                'title' => esc_html__('Top', 'gbx'),
                'icon' => 'eicon-v-align-top',
            ],
            'center' => [
                'title' => esc_html__('Middle', 'gbx'),
                'icon' => 'eicon-v-align-middle',
            ],
            'flex-end' => [
                'title' => esc_html__('Bottom', 'gbx'),
                'icon' => 'eicon-v-align-bottom',
            ],
        ],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}}' => 'align-items: {{VALUE}}',
        ],
        'label_block' => false,
        'description' => esc_html__('Set the vertical align of this block', 'gbx'),
        'condition'  => [
            'field_type' => ['column', 'text', 'image', 'button', 'meta', 'utilities'],
        ],
    ]
);


// horizontal align
$repeater->add_responsive_control(
    'gbx_repeater_horizontal_align',
    [
        'label' => esc_html__('Horizontal Align', 'gbx'),
        'type' => \Elementor\Controls_Manager::CHOOSE,
        'options' => [
            'flex-start' => [
                'title' => esc_html__('Left', 'gbx'),
                'icon' => 'eicon-h-align-left',
            ],
            'center' => [
                'title' => esc_html__('Center', 'gbx'),
                'icon' => 'eicon-h-align-center',
            ],
            'flex-end' => [
                'title' => esc_html__('Right', 'gbx'),
                'icon' => 'eicon-h-align-right',
            ],
        ],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}}' => 'justify-content: {{VALUE}}',
        ],
        'label_block' => false,
        'description' => esc_html__('Set the horizontal align of this block', 'gbx'),
        'condition'  => [
            'field_type' => ['column', 'text', 'image', 'button', 'meta', 'utilities'],
        ],
    ]
);

// Headline
$repeater->add_control(
    'gbx_repeater_heading_headline_acs',
    [
        'label'     => esc_html__('Border for Wrapper', 'gbx'),
        'type'      => \Elementor\Controls_Manager::HEADING,
        'separator' => 'before',
    ]
);

$repeater->add_group_control(
    \Elementor\Group_Control_Border::get_type(),
    [
        'name'     => 'gbx_repeater_border',
        'label'    => esc_html__('Border', 'gbx'),
        'selector' => '{{WRAPPER}} {{CURRENT_ITEM}}',
    ]
);

// Headline
$repeater->add_control(
    'gbx_repeater_heading_headline_adsa_ca',
    [
        'label'     => esc_html__('Border for grid element', 'gbx'),
        'type'      => \Elementor\Controls_Manager::HEADING,
        'separator' => 'before',
    ]
);


$repeater->add_group_control(
    \Elementor\Group_Control_Border::get_type(),
    [
        'name'     => 'gbx_repeater_border_container',
        'label'    => esc_html__('Container Border', 'gbx'),
        'selector' => '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-repeater-item-inner',
    ]
);

//divider
$repeater->add_control(
    'gbx_repeater_divider_218128',
    [
        'type' => \Elementor\Controls_Manager::DIVIDER,
    ]
);

$repeater->add_responsive_control(
    'gbx_repeater_border_radius',
    [
        'label'      => esc_html__('Wrapper border radius', 'gbx'),
        'type'       => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%'],
        'selectors'  => [
            '{{WRAPPER}} {{CURRENT_ITEM}}' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
    ]
);


//border radius
$repeater->add_responsive_control(
    'gbx_repeater_border_radius_container',
    [
        'label'      => esc_html__('Grid element border radius', 'gbx'),
        'type'       => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%'],
        'selectors'  => [
            '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-repeater-item-inner' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
    ]
);




$repeater->add_group_control(
    \Elementor\Group_Control_Text_Shadow::get_type(),
    [
        'name'     => 'gbx_repeater_text_shadow',
        'label'    => esc_html__('Text Shadow', 'gbx'),
        'selector' => '{{WRAPPER}} {{CURRENT_ITEM}}',
        'condition'  => [
            'field_type' => ['text'],
        ],
    ]
);

// padding control
$repeater->add_responsive_control(
    'gbx_repeater_padding',
    [
        'label'      => esc_html__('Padding', 'gbx'),
        'type'       => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors'  => [
            '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-repeater-item-inner' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
    ]
);

// margin control
$repeater->add_responsive_control(
    'gbx_repeater_margin',
    [
        'label'      => esc_html__('Margin', 'gbx'),
        'type'       => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors'  => [
            '{{WRAPPER}} {{CURRENT_ITEM}} .gbx-repeater-item-inner' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
    ]
);
