<?php

//direct access  die
defined('ABSPATH') || die();

$this->add_group_control(
    \Elementor\Group_Control_Typography::get_type(),
    [
        'name' => 'gbx_meta_grid_filter_checkbox_typography',
        'label' => esc_html__('Typography', 'gbx'),
        'selector' => '{{WRAPPER}} .gbx__filter__wrapper .ui.checkbox label',
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['checkbox', 'radio', 'icons-checkbox', 'icons-radio'],
        ],
    ]
);


//check box color
$this->add_control(
    'gbx__meta_grid_filter_checkbox_color',
    [
        'label' => esc_html__('Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '#000000',
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .ui.checkbox label' => 'color: {{VALUE}};',
            '{{WRAPPER}} .gbx__filter__wrapper .ui.checkbox label span'  => 'color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['checkbox', 'radio'],
        ],
    ]
);


//check box background color
$this->add_control(
    'gbx__meta_grid_filter_checkbox_background_color',
    [
        'label' => esc_html__('Background Color of Options', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '#ffffff',
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .ui.checkbox' => 'background-color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['checkbox', 'radio'],
        ],
    ]
);


// background of checked box color
$this->add_control(
    'gbx__meta_grid_filter_checkbox_checked_color',
    [
        'label' => esc_html__('Background Color of UnChecked Options', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '#ffffff',
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .ui.checkbox label:before' => 'background-color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['checkbox'],
        ],
    ]
);



// border grup control
$this->add_group_control(
    \Elementor\Group_Control_Border::get_type(),
    [
        'name' => 'gbx__meta_grid_filter_checkbox_border',
        'label' => esc_html__('Border', 'gbx'),
        'selector' => '{{WRAPPER}} .gbx__filter__wrapper .ui.checkbox',
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['checkbox', 'radio'],
        ],
    ]
);


//check box border radius
$this->add_control(
    'gbx__meta_grid_filter_checkbox_border_radius',
    [
        'label' => esc_html__('Border Radius', 'gbx'),
        'type' => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['px'],
        'range' => [
            'px' => [
                'min' => 0,
                'max' => 100,
                'step' => 1,
            ],
        ],
        'default' => [
            'unit' => 'px',
            'size' => 0,
        ],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .ui.checkbox' => 'border-radius: {{SIZE}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['checkbox', 'radio',],
        ],
    ]
);

//check box border radius for label
$this->add_control(
    'gbx__meta_grid_filter_checkbox_border_radius_label',
    [
        'label' => esc_html__('Border Radius', 'gbx'),
        'type' => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['px'],
        'range' => [
            'px' => [
                'min' => 0,
                'max' => 100,
                'step' => 1,
            ],
        ],
        'default' => [
            'unit' => 'px',
            'size' => 0,
        ],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .ui.checkbox label' => 'border-radius: {{SIZE}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['icons-checkbox', 'icons-radio'],
        ],
    ]
);

//check box padding
$this->add_control(
    'gbx__meta_grid_filter_checkbox_padding',
    [
        'label' => esc_html__('Padding', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .ui.checkbox' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['checkbox', 'radio'],
        ],
    ]
);

//check box margin
$this->add_control(
    'gbx__meta_grid_filter_checkbox_margin',
    [
        'label' => esc_html__('Margin', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .ui.checkbox' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['checkbox', 'radio'],
        ],
    ]
);

// label spefic padding
$this->add_control(
    'gbx__meta_grid_filter_checkbox_label_padding',
    [
        'label' => esc_html__('Label Padding', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .ui.checkbox label' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['icons-checkbox', 'icons-radio'],
        ],
    ]
);

// label spefic margin
$this->add_control(
    'gbx__meta_grid_filter_checkbox_label_margin',
    [
        'label' => esc_html__('Label Margin', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .ui.checkbox label' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['icons-checkbox', 'icons-radio'],
        ],
    ]
);

// check box label padding
$this->add_control(
    'gbx__meta_grid_filter_checkbox_label_padding_label_alone',
    [
        'label' => esc_html__('Label Padding', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .ui.checkbox label' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['checkbox', 'radio'],
        ],
    ]
);

// check box before margin
$this->add_control(
    'gbx__meta_grid_filter_checkbox_before_margin_label_alone',
    [
        'label' => esc_html__('Checker Box', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .ui.checkbox label:before' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['checkbox', 'radio'],
        ],
    ]
);

// checker tick margin
$this->add_control(
    'gbx__meta_grid_filter_checkbox_tick_margin_label_alone',
    [
        'label' => esc_html__('Checker Tick Adjustment', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .ui.checkbox label:after' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['checkbox', 'radio'],
        ],
    ]
);

// check box direction select
$this->add_control(
    'gbx__meta_grid_filter_checkbox_direction',
    [
        'label' => esc_html__('Direction', 'gbx'),
        'type' => \Elementor\Controls_Manager::SELECT,
        'default' => 'row',
        'options' => [
            'row' => esc_html__('Row', 'gbx'),
            'column' => esc_html__('Column', 'gbx'),
        ],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__meta__checkbox-group' => 'flex-direction: {{VALUE}};',
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__meta__radio-group' => 'flex-direction: {{VALUE}};',
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__icon-checkbox-group' => 'flex-direction: {{VALUE}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['checkbox', 'radio', 'icons-checkbox', 'icons-radio']
        ],
    ]
);

// MIN width of checkbox
$this->add_control(
    'gbx__meta_grid_filter_checkbox_min_width',
    [
        'label' => esc_html__('Width', 'gbx'),
        'type' => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['px', '%'],
        'range' => [
            'px' => [
                'min' => 0,
                'max' => 1000,
                'step' => 1,
            ],
        ],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__meta__checkbox' => 'width:max-content; min-width: {{SIZE}}{{UNIT}};',
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__meta__radio-group' => 'width:max-content; min-width: {{SIZE}}{{UNIT}};',
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__icon-checkbox-group' => 'width:max-content; min-width: {{SIZE}}{{UNIT}};',
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__meta__radio' => 'width:max-content; min-width: {{SIZE}}{{UNIT}};',
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__meta__icon-checkbox' => 'width:max-content; min-width: {{SIZE}}{{UNIT}};',
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__meta__icon-radio' => 'width:max-content; min-width: {{SIZE}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['checkbox', 'radio', 'icons-checkbox', 'icons-radio'],
        ],
    ]
);

// min height of svg and i inside the label
$this->add_control(
    'gbx__meta_grid_filter_checkbox_min_height',
    [
        'label' => esc_html__('Height', 'gbx'),
        'type' => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['px', '%'],
        'range' => [
            'px' => [
                'min' => 0,
                'max' => 1000,
                'step' => 1,
            ],
        ],
        'default' => [
            'unit' => 'px',
            'size' => 20,
        ],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__icon-checkbox-group label svg' => 'min-height: {{SIZE}}{{UNIT}};',
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__icon-checkbox-group label i' => 'min-height: {{SIZE}}{{UNIT}};',

        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['icons-checkbox', 'icons-radio'],
        ],
    ]
);
