<?php

if (!defined('ABSPATH')) exit; // Exit if accessed directly


// filter button color
$this->add_control(
    'gbx_grid_filter_button_color',
    [
        'label' => esc_html__('Button Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '#ffffff',
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__remove-filter' => 'color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => 'clear',
        ],
    ]
);

// filter button background color
$this->add_control(
    'gbx_grid_filter_button_background_color',
    [
        'label' => esc_html__('Button Background Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '#000000',
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__remove-filter' => 'background-color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => 'clear',
        ],
    ]
);

// filter button typography
$this->add_group_control(
    \Elementor\Group_Control_Typography::get_type(),
    [
        'name' => 'gbx_grid_filter_button_typography',
        'label' => esc_html__('Typography', 'gbx'),
        'selector' => '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__remove-filter',
        'condition' => [
            'gbx_grid_filter_mode' => 'clear',
        ],
    ]
);

// filter button border group control
$this->add_group_control(
    \Elementor\Group_Control_Border::get_type(),
    [
        'name' => 'gbx_grid_filter_button_border',
        'label' => esc_html__('Border', 'gbx'),
        'selector' => '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__remove-filter',
        'condition' => [
            'gbx_grid_filter_mode' => 'clear',
        ],
    ]
);

// filter button border radius
$this->add_control(
    'gbx_grid_filter_button_border_radius',
    [
        'label' => esc_html__('Border Radius', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__remove-filter' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => 'clear',
        ],
    ]
);

// filter button padding
$this->add_control(
    'gbx_grid_filter_button_padding',
    [
        'label' => esc_html__('Padding', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__remove-filter' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => 'clear',
        ],
    ]
);

// filter button margin
$this->add_control(
    'gbx_grid_filter_button_margin',
    [
        'label' => esc_html__('Margin', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__remove-filter' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => 'clear',
        ],
    ]
);

// all clear button typography
$this->add_group_control(
    \Elementor\Group_Control_Typography::get_type(),
    [
        'name' => 'gbx_grid_filter_all_clear_button_typography',
        'label' => esc_html__('Typography', 'gbx'),
        'selector' => '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__clear-filters',
        'condition' => [
            'gbx_grid_filter_mode' => 'clear',
        ],
    ]
);


// all clear button color
$this->add_control(
    'gbx_grid_filter_all_clear_button_color',
    [
        'label' => esc_html__('All Clear Button Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '#ffffff',
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__clear-filters' => 'color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => 'clear',
        ],
    ]
);

// all clear button background color
$this->add_control(
    'gbx_grid_filter_all_clear_button_background_color',
    [
        'label' => esc_html__('All Clear Button Background Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '#000000',
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__clear-filters' => 'background-color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => 'clear',
        ],
    ]
);

// all clear button border group control
$this->add_group_control(
    \Elementor\Group_Control_Border::get_type(),
    [
        'name' => 'gbx_grid_filter_all_clear_button_border',
        'label' => esc_html__('Border', 'gbx'),
        'selector' => '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__clear-filters',
        'condition' => [
            'gbx_grid_filter_mode' => 'clear',
        ],
    ]
);

// all clear button border radius
$this->add_control(
    'gbx_grid_filter_all_clear_button_border_radius',
    [
        'label' => esc_html__('Border Radius', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__clear-filters' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => 'clear',
        ],
    ]
);

// all clear button padding
$this->add_control(
    'gbx_grid_filter_all_clear_button_padding',
    [
        'label' => esc_html__('Padding', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__clear-filters' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => 'clear',
        ],
    ]
);

// all clear button margin
$this->add_control(
    'gbx_grid_filter_all_clear_button_margin',
    [
        'label' => esc_html__('Margin', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__clear-filters' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => 'clear',
        ],
    ]
);
