<?php

// define abs pat
//direct access  die
defined('ABSPATH') || die();


// dropdown width
$this->add_control(
    'gbx__orderby_grid_filter_dropdown_width',
    [
        'label' => esc_html__('Dropdown Width', 'gbx'),
        'type' => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['px', '%'],
        'range' => [
            'px' => [
                'min' => 0,
                'max' => 1000,
                'step' => 1,
            ],
            '%' => [
                'min' => 0,
                'max' => 100,
                'step' => 1,
            ],
        ],
        'default' => [
            'unit' => '%',
            'size' => 100,
        ],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .ui.selection.dropdown' => 'width: {{SIZE}}{{UNIT}};',
        ],
        // filter condition - Filter Mode Taxonomy and visual element is dropdown
        'condition' => [
            'gbx_grid_filter_mode' => 'orderby',
        ],

    ]
);

// background color
$this->add_control(
    'gbx__orderby_grid_filter_background_color',
    [
        'label' => esc_html__('Background Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '#ffffff',
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .ui.selection.dropdown' => 'background-color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => 'orderby',
        ],
    ]
);

//typography
$this->add_group_control(
    \Elementor\Group_Control_Typography::get_type(),
    [
        'name' => 'gbx_orderby_grid_filter_typography',
        'label' => esc_html__('Typography', 'gbx'),
        'selector' => '{{WRAPPER}} .gbx__filter__wrapper .ui.selection.dropdown',
        'condition' => [
            'gbx_grid_filter_mode' => 'orderby',
        ],
    ]
);

// typography for options
$this->add_group_control(
    \Elementor\Group_Control_Typography::get_type(),
    [
        'name' => 'gbx_orderby_grid_filter_options_typography',
        'label' => esc_html__('Options Typography', 'gbx'),
        'selector' => '{{WRAPPER}} .gbx__filter__wrapper .ui.selection.dropdown .menu .item',
        'condition' => [
            'gbx_grid_filter_mode' => 'orderby',
        ],
    ]
);

//text color
$this->add_control(
    'gbx_orderby_grid_filter_text_color',
    [
        'label' => esc_html__('Text Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '#000000',
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .ui.selection.dropdown' => 'color: {{VALUE}};',
            '{{WRAPPER}} .gbx__filter__wrapper .ui.multiple.dropdown > .label' => 'border:1px solid; box-shadow:none; border-color: {{VALUE}};',
            '{{WRAPPER}} .gbx__filter__wrapper .ui.dropdown:not(.button) > .default.text' => 'opacity:0.8; color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => 'orderby',
        ],
    ]
);

// border group control
$this->add_group_control(
    \Elementor\Group_Control_Border::get_type(),
    [
        'name' => 'gbx_orderby_grid_filter_border',
        'label' => esc_html__('Border', 'gbx'),
        'selector' => '{{WRAPPER}} .gbx__filter__wrapper .ui.selection.dropdown',
        'condition' => [
            'gbx_grid_filter_mode' => 'orderby',
        ],
    ]
);


// border radius
$this->add_control(
    'gbx_orderby_grid_filter_border_radius',
    [
        'label' => esc_html__('Border Radius', 'gbx'),
        'type' => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['px'],
        'range' => [
            'px' => [
                'min' => 0,
                'max' => 100,
                'step' => 1,
            ],
        ],
        'default' => [
            'unit' => 'px',
            'size' => 0,
        ],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .ui.selection.dropdown' => 'border-radius: {{SIZE}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => 'orderby',
        ],
    ]
);

//dropdown background color
$this->add_control(
    'gbx_orderby_grid_filter_dropdown_background_color',
    [
        'label' => esc_html__('Dropdown Background Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '#ffffff',
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .ui.selection.active.dropdown .menu' => 'background-color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => 'orderby',
        ],
    ]
);

// color
$this->add_control(
    'gbx_orderby_grid_filter_dropdown_color',
    [
        'label' => esc_html__('Dropdown Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '#000000',
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .ui.selection.dropdown .menu > .item' => 'color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => 'orderby',
        ],
    ]
);
