<?php
defined('ABSPATH') || exit;

// filter type
$this->add_control(
    'gbx_grid_filter_mode',
    [
        'label' => esc_html__('Filter Mode', 'gbx'),
        'type' => \Elementor\Controls_Manager::SELECT,
        'default' => 'none',
        'options' => [
            'none' => esc_html__('None', 'gbx'),
            'taxonomy' => esc_html__('Taxonomy', 'gbx'),
            'meta' => esc_html__('Meta', 'gbx'),
            'search' => esc_html__('Search', 'gbx'),
            'orderby' => esc_html__('Order By', 'gbx'),
            'clear' => esc_html__('Clear', 'gbx'),
        ],
    ]
);

// visual element - dropdown, checkbox, radio , search
$this->add_control(
    'gbx_grid_filter_visual_element_taxonomy',
    [
        'label' => esc_html__('Visual Element', 'gbx'),
        'type' => \Elementor\Controls_Manager::SELECT,
        'default' => 'dropdown',
        'options' => [
            'dropdown' => esc_html__('Dropdown', 'gbx'),
            'checkbox' => esc_html__('Checkbox', 'gbx'),
            'radio' => esc_html__('Radio', 'gbx'),
            'icons-checkbox' => esc_html__('Icons Checkbox', 'gbx'),
            'icons-radio' => esc_html__('Icons Radio', 'gbx'),
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['taxonomy'],
        ],
    ]
);

// list of taxonomies
$this->add_control(
    'gbx_grid_filter_taxonomy_list',
    [
        'label' => esc_html__('Taxonomy', 'gbx'),
        'type' => \Elementor\Controls_Manager::SELECT2,
        'multiple' => false,
        'options' => \GRIDBUILDERX\Utils::get_list_of_all_taxonomies(),
        'condition' => [
            'gbx_grid_filter_mode' => ['taxonomy'],
        ],
    ]
);

// clear filter button text
$this->add_control(
    'gbx_grid_filter_clear_button_text',
    [
        'label' => esc_html__('Clear Button Text', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
        'default' => esc_html__('Clear', 'gbx'),
        'condition' => [
            'gbx_grid_filter_mode' => ['clear'],
        ],
    ]
);

// hide icon text
$this->add_control(
    'gbx_grid_filter_hide_icon_text_taxonomy',
    [
        'label' => esc_html__('Display Icon Text', 'gbx'),
        'type' => \Elementor\Controls_Manager::SWITCHER,
        'label_on' => esc_html__('Yes', 'gbx'),
        'label_off' => esc_html__('No', 'gbx'),
        'return_value' => 'yes',
        'default' => 'no',
        'condition' => [
            'gbx_grid_filter_mode' => ['taxonomy'],
            'gbx_grid_filter_visual_element_taxonomy' => ['icons-checkbox', 'icons-radio'],
        ],
    ]
);


// hide icon text
$this->add_control(
    'gbx_grid_filter_hide_icon_text_meta',
    [
        'label' => esc_html__('Display Icon Text', 'gbx'),
        'type' => \Elementor\Controls_Manager::SWITCHER,
        'label_on' => esc_html__('Yes', 'gbx'),
        'label_off' => esc_html__('No', 'gbx'),
        'return_value' => 'yes',
        'default' => 'no',
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['icons-checkbox', 'icons-radio'],
        ],
    ]
);

// placeholder order by
$this->add_control(
    'gbx_grid_filter_placeholder_orderby',
    [
        'label' => esc_html__('Placeholder Text', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
        'default' => esc_html__('Order By', 'gbx'),
        'condition' => [
            'gbx_grid_filter_mode' => ['orderby'],
        ],
    ]
);

//placeholder text for search
$this->add_control(
    'gbx_grid_filter_placeholder_search',
    [
        'label' => esc_html__('Placeholder Text', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
        'default' => esc_html__('Search', 'gbx'),
        'condition' => [
            'gbx_grid_filter_mode' => ['search'],
        ],
    ]
);

//place holder text
$this->add_control(
    'gbx_grid_filter_placeholder_taxonomy',
    [
        'label' => esc_html__('Placeholder Text', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
        'default' => esc_html__('Select', 'gbx'),
        'condition' => [
            'gbx_grid_filter_mode' => ['taxonomy'],
            'gbx_grid_filter_visual_element_taxonomy' => ['dropdown', 'radio',],
        ],
    ]
);

//place holder text
$this->add_control(
    'gbx_grid_filter_placeholder_meta',
    [
        'label' => esc_html__('Placeholder Text', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
        'default' => esc_html__('Select', 'gbx'),
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['dropdown', 'radio'],
        ],
    ]
);

// collapse after how many items - number control with default 10
$this->add_control(
    'gbx_grid_filter_collapse_taxonomy',
    [
        'label' => esc_html__('Collapse After 10 Items', 'gbx'),
        'type' => \Elementor\Controls_Manager::NUMBER,
        'default' => 10,
        'condition' => [
            'gbx_grid_filter_mode' => ['taxonomy'],
            'gbx_grid_filter_visual_element_taxonomy' => ['checkbox', 'radio'],
        ],
    ]
);



// collapse radio or checkbox after 10 items yes or no for meta
$this->add_control(
    'gbx_grid_filter_collapse_meta',
    [
        'label' => esc_html__('Collapse After 10 Items', 'gbx'),
        'type' => \Elementor\Controls_Manager::NUMBER,
        'default' => 10,
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['checkbox', 'radio'],
        ],
    ]
);

// multiple select
$this->add_control(
    'gbx_grid_filter_multiple_select_taxonomy',
    [
        'label' => esc_html__('Multiple Select', 'gbx'),
        'type' => \Elementor\Controls_Manager::SWITCHER,
        'label_on' => esc_html__('Yes', 'gbx'),
        'label_off' => esc_html__('No', 'gbx'),
        'return_value' => 'multiple',
        'default' => '',
        'condition' => [
            'gbx_grid_filter_mode' => ['taxonomy'],
            'gbx_grid_filter_visual_element_taxonomy' => ['dropdown'],
        ],
    ]
);

$repeater_filter_taxonomy = new \Elementor\Repeater();

// title 
$repeater_filter_taxonomy->add_control(
    'gbx_taxonomy_filter_title',
    [
        'label' => esc_html__('Display Text', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
    ]
);

// taxonomy slug text
$repeater_filter_taxonomy->add_control(
    'gbx_taxonomy_filter',
    [
        'label' => esc_html__('Taxonomy Slug', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
    ]
);

// image icon
$repeater_filter_taxonomy->add_control(
    'gbx_taxonomy_filter_icon',
    [
        'label' => esc_html__('Icon', 'gbx'),
        'type' => \Elementor\Controls_Manager::ICONS,
    ]
);

// color icon
$repeater_filter_taxonomy->add_control(
    'gbx_taxonomy_filter_icon_color',
    [
        'label' => esc_html__('Icon Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} label' => 'color: {{VALUE}}',
            '{{WRAPPER}} {{CURRENT_ITEM}} label i' => 'color: {{VALUE}}',
            '{{WRAPPER}} {{CURRENT_ITEM}} label svg' => 'fill: {{VALUE}}',
        ],
    ]
);

// background color icon
$repeater_filter_taxonomy->add_control(
    'gbx_taxonomy_filter_icon_bg_color',
    [
        'label' => esc_html__('Icon Background Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
            // target the label background color
            '{{WRAPPER}} {{CURRENT_ITEM}} label' => 'background-color: {{VALUE}}',
        ],
    ]
);

// add the repeater control
$this->add_control(
    'gbx_taxonomy_filter_list',
    [
        'label' => esc_html__('Taxonomy Filter List', 'gbx'),
        'type' => \Elementor\Controls_Manager::REPEATER,
        'fields' => $repeater_filter_taxonomy->get_controls(),
        'title_field' => '{{{ gbx_taxonomy_filter_title }}}',
        'condition' => [
            'gbx_grid_filter_mode' => ['taxonomy'],
        ],
        // allow empty repeater
        'prevent_empty' => false,
    ]
);

// visal element for meta
$this->add_control(
    'gbx_grid_filter_visual_element_meta',
    [
        'label' => esc_html__('Visual Element', 'gbx'),
        'type' => \Elementor\Controls_Manager::SELECT,
        'default' => 'dropdown',
        'options' => [
            'dropdown' => esc_html__('Dropdown', 'gbx'),
            'checkbox' => esc_html__('Checkbox', 'gbx'),
            'radio' => esc_html__('Radio', 'gbx'),
            'slider' => esc_html__('Slider', 'gbx'),
            'icons-checkbox' => esc_html__('Icons Checkbox', 'gbx'),
            'icons-radio' => esc_html__('Icons Radio', 'gbx'),
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
        ],
    ]
);


$repeater_filter_orderby = new \Elementor\Repeater();

// display text
$repeater_filter_orderby->add_control(
    'gbx_orderby_filter_display',
    [
        'label' => esc_html__('Display Text', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
    ]
);

// orderby value
$repeater_filter_orderby->add_control(
    'gbx_orderby_filter',
    [
        'label' => esc_html__('Order By', 'gbx'),
        'type' => \Elementor\Controls_Manager::SELECT,
        'default' => 'none',
        'options' => [
            'none' => esc_html__('None', 'gbx'),
            'ID' => esc_html__('ID', 'gbx'),
            'author' => esc_html__('Author', 'gbx'),
            'title' => esc_html__('Title', 'gbx'),
            'name' => esc_html__('Name', 'gbx'),
            'date' => esc_html__('Date', 'gbx'),
            'modified' => esc_html__('Modified', 'gbx'),
            'rand' => esc_html__('Rand', 'gbx'),
            'comment_count' => esc_html__('Comment Count', 'gbx'),
            'menu_order' => esc_html__('Menu Order', 'gbx'),
            'meta_value' => esc_html__('Meta Value', 'gbx'),
            'meta_value_num' => esc_html__('Meta Value Num', 'gbx'),
        ],
    ]
);

//order
$repeater_filter_orderby->add_control(
    'gbx_orderby_filter_order',
    [
        'label' => esc_html__('Order', 'gbx'),
        'type' => \Elementor\Controls_Manager::SELECT,
        'default' => 'none',
        'options' => [
            'none' => esc_html__('None', 'gbx'),
            'ASC' => esc_html__('ASC', 'gbx'),
            'DESC' => esc_html__('DESC', 'gbx'),
        ],
    ]
);

// meta key
$repeater_filter_orderby->add_control(
    'gbx_orderby_filter_meta_key',
    [
        'label' => esc_html__('Meta Key', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
        'condition' => [
            'gbx_orderby_filter' => ['meta_value', 'meta_value_num'],
        ],
    ]
);

// add the repeater to the control
$this->add_control(
    'gbx_grid_filter_order_by_repeater',
    [
        'label' => esc_html__('Options', 'gbx'),
        'type' => \Elementor\Controls_Manager::REPEATER,
        'fields' => $repeater_filter_orderby->get_controls(),
        'title_field' => '{{{ gbx_orderby_filter_display }}}',
        'condition' => [
            'gbx_grid_filter_mode' => ['orderby'],
        ],
    ]
);



$repeater_filter_meta_query = new \Elementor\Repeater();

//meta key
$repeater_filter_meta_query->add_control(
    'gbx_meta_query_meta_key_filter_display',
    [
        'label' => esc_html__('Display Text', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
    ]
);


//meta key
$repeater_filter_meta_query->add_control(
    'gbx_meta_query_meta_key_filter',
    [
        'label' => esc_html__('Meta Key', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
    ]
);

//meta value
$repeater_filter_meta_query->add_control(
    'gbx_meta_query_meta_value_filter',
    [
        'label' => esc_html__('Meta Value', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
    ]
);

// meta icon
$repeater_filter_meta_query->add_control(
    'gbx_meta_query_meta_icon_filter',
    [
        'label' => esc_html__('Icon', 'gbx'),
        'type' => \Elementor\Controls_Manager::ICONS,
    ]
);

// color icon
$repeater_filter_meta_query->add_control(
    'gbx_meta_filter_icon_color',
    [
        'label' => esc_html__('Icon Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} label' => 'color: {{VALUE}}',
            '{{WRAPPER}} {{CURRENT_ITEM}} label i' => 'color: {{VALUE}}',
            '{{WRAPPER}} {{CURRENT_ITEM}} label svg' => 'fill: {{VALUE}}',
        ],
    ]
);

// background color icon
$repeater_filter_meta_query->add_control(
    'gbx_meta_filter_icon_bg_color',
    [
        'label' => esc_html__('Icon Background Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
            // target the label background color
            '{{WRAPPER}} {{CURRENT_ITEM}} label' => 'background-color: {{VALUE}}',
        ],
    ]
);

// icon width
$repeater_filter_meta_query->add_control(
    'gbx_meta_filter_icon_width',
    [
        'label' => esc_html__('Icon Width', 'gbx'),
        'type' => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['px', '%'],
        'range' => [
            'px' => [
                'min' => 10,
                'max' => 100,
            ],
            '%' => [
                'min' => 10,
                'max' => 100,
            ],
        ],
        'selectors' => [
            '{{WRAPPER}} {{CURRENT_ITEM}} label svg' => 'width: {{SIZE}}{{UNIT}} !important',
            '{{WRAPPER}} {{CURRENT_ITEM}} label i' => 'font-size: {{SIZE}}{{UNIT}} !important',
        ],
        'default' => [
            'unit' => 'px',
            'size' => 18,
        ],
    ]
);


// add the repeater to the control
$this->add_control(
    'gbx_grid_filter_meta_query',
    [
        'label' => esc_html__('Options', 'gbx'),
        'type' => \Elementor\Controls_Manager::REPEATER,
        'fields' => $repeater_filter_meta_query->get_controls(),
        'title_field' => '{{{ gbx_meta_query_meta_key_filter }}}',
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['dropdown', 'checkbox', 'radio', 'icons-checkbox', 'icons-radio'],
        ],
    ]
);

// meta min value
$this->add_control(
    'gbx_grid_filter_meta_slider_key',
    [
        'label' => esc_html__('Meta Key', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['slider'],
        ],
    ]
);

// value of slider
$this->add_control(
    'gbx_grid_filter_meta_slider_value_min',
    [
        'label' => esc_html__('Min Value', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['slider'],
        ],
        'default' => '0',
    ]
);

// value of slider
$this->add_control(
    'gbx_grid_filter_meta_slider_value_max',
    [
        'label' => esc_html__('Max Value', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['slider'],
        ],
        'default' => '100',
    ]
);

//start value of slider
$this->add_control(
    'gbx_grid_filter_meta_slider_start',
    [
        'label' => esc_html__('Start Value', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['slider'],
        ],
        'default' => '0',
        'description' => esc_html__('For range make it comma seprated', 'gbx'),
    ]
);

//step value of slider number
$this->add_control(
    'gbx_grid_filter_meta_slider_step',
    [
        'label' => esc_html__('Step Value', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
            'gbx_grid_filter_visual_element_meta' => ['slider'],
        ],
        'default' => '1',
    ]
);


// meta operator
$this->add_control(
    'gbx_grid_filter_meta_operator',
    [
        'label' => esc_html__('Meta Operator', 'gbx'),
        'type' => \Elementor\Controls_Manager::SELECT,
        'default' => 'IN',
        'options' => [
            '=' => esc_html__('=', 'gbx'),
            '!=' => esc_html__('!=', 'gbx'),
            '>' => esc_html__('>', 'gbx'),
            '>=' => esc_html__('>=', 'gbx'),
            '<' => esc_html__('<', 'gbx'),
            '<=' => esc_html__('<=', 'gbx'),
            'LIKE' => esc_html__('LIKE', 'gbx'),
            'NOT LIKE' => esc_html__('NOT LIKE', 'gbx'),
            'IN' => esc_html__('IN', 'gbx'),
            'NOT IN' => esc_html__('NOT IN', 'gbx'),
            'BETWEEN' => esc_html__('BETWEEN', 'gbx'),
            'NOT BETWEEN' => esc_html__('NOT BETWEEN', 'gbx'),
            'EXISTS' => esc_html__('EXISTS', 'gbx'),
            'NOT EXISTS' => esc_html__('NOT EXISTS', 'gbx'),
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['meta'],
        ],
    ]
);

// meta type - char, 
$this->add_control(
    'gbx_grid_filter_meta_operator_type',
    [
        'label' => esc_html__('Meta Operator Type', 'gbx'),
        'type' => \Elementor\Controls_Manager::SELECT,
        'default' => 'CHAR',
        'options' => [
            'CHAR' => esc_html__('CHAR', 'gbx'),
            'NUMERIC' => esc_html__('NUMERIC', 'gbx'),
            'BINARY' => esc_html__('BINARY', 'gbx'),
            'DATE' => esc_html__('DATE', 'gbx'),
            'DATETIME' => esc_html__('DATETIME', 'gbx'),
            'SIGNED' => esc_html__('DATETIME', 'gbx'),
            'TIME' => esc_html__('TIME', 'gbx'),
            'UNSIGNED' => esc_html__('UNSIGNED', 'gbx'),
            'DECIMAL' => esc_html__('DECIMAL', 'gbx'),
        ]
    ]
);

// search icon icons control
$this->add_control(
    'gbx_grid_filter_meta_search_icon',
    [
        'label' => esc_html__('Search Icon', 'gbx'),
        'type' => \Elementor\Controls_Manager::ICONS,
        'condition' => [
            'gbx_grid_filter_mode' => ['search'],
        ],
    ]
);

// search icon color
$this->add_control(
    'gbx_grid_filter_meta_search_icon_color',
    [
        'label' => esc_html__('Search Icon Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'condition' => [
            'gbx_grid_filter_mode' => ['search'],
        ],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__search .gbx__filter__search__icon i' => 'color: {{VALUE}};',
            '{{WRAPPER}} .gbx__filter__search .gbx__filter__search__icon svg' => 'fill: {{VALUE}};',
        ],
    ]
);

// search icon size
$this->add_control(
    'gbx_grid_filter_meta_search_icon_size',
    [
        'label' => esc_html__('Search Icon Size', 'gbx'),
        'type' => \Elementor\Controls_Manager::SLIDER,
        'condition' => [
            'gbx_grid_filter_mode' => ['search'],
        ],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__search .gbx__filter__search__icon i' => 'font-size: {{SIZE}}{{UNIT}};',
            '{{WRAPPER}} .gbx__filter__search .gbx__filter__search__icon svg' => 'width: {{SIZE}}{{UNIT}}; height: {{SIZE}}{{UNIT}};',
        ],
        'default' => [
            'size' => 16,
            'unit' => 'px',
        ],
    ]
);
