<?php

//direct access is denied
defined('ABSPATH') || die();


// search background color
$this->add_control(
    'gbx_grid_filter_search_background_color',
    [
        'label' => esc_html__('Background Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '#ffffff',
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__search__icon_container' => 'background-color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['search'],
        ],
    ]
);

// text color
$this->add_control(
    'gbx_grid_filter_search_text_color',
    [
        'label' => esc_html__('Text Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '#000000',
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__search input' => 'color: {{VALUE}};',
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__search input::placeholder' => 'opacity:0.6;color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['search'],
        ],
    ]
);

// search border group control
$this->add_group_control(
    \Elementor\Group_Control_Border::get_type(),
    [
        'name' => 'gbx_grid_filter_search_border',
        'label' => esc_html__('Border', 'gbx'),
        'selector' => '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__search .gbx__filter__search__icon_container',
        'condition' => [
            'gbx_grid_filter_mode' => ['search'],
        ],
    ]
);

// search border radius
$this->add_control(
    'gbx_grid_filter_search_border_radius',
    [
        'label' => esc_html__('Border Radius', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%'],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__search .gbx__filter__search__icon_container' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['search'],
        ],
    ]
);

// search padding
$this->add_control(
    'gbx_grid_filter_search_padding',
    [
        'label' => esc_html__('Padding', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%'],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__search input' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['search'],
        ],
    ]
);

// search margin
$this->add_control(
    'gbx_grid_filter_search_margin',
    [
        'label' => esc_html__('Margin', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%'],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .gbx__filter__search input' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => ['search'],
        ],
    ]
);
