<?php

if (!defined('ABSPATH')) exit; // Exit if accessed directly

// slider spcific controls

//slider background color
$this->add_control(
    'gbx_grid_slider_background_color',
    [
        'label' => esc_html__('Slider Background Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '#ffffff',
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .noUi-target' => 'background-color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => 'meta',
            'gbx_grid_filter_visual_element_meta' => 'slider',
        ],
    ]
);

//slider handle color
$this->add_control(
    'gbx_grid_slider_handle_color',
    [
        'label' => esc_html__('Slider Handle Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '#000000',
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .noUi-handle' => 'background-color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => 'meta',
            'gbx_grid_filter_visual_element_meta' => 'slider',
        ],
    ]
);

// slider hande border group control
$this->add_group_control(
    \Elementor\Group_Control_Border::get_type(),
    [
        'name' => 'gbx_grid_slider_handle_border',
        'label' => esc_html__('Slider Handle Border', 'gbx'),
        'selector' => '{{WRAPPER}} .gbx__filter__wrapper .noUi-handle',
        'condition' => [
            'gbx_grid_filter_mode' => 'meta',
            'gbx_grid_filter_visual_element_meta' => 'slider',
        ],
    ]
);

//slider handle border radius
$this->add_control(
    'gbx_grid_slider_handle_border_radius',
    [
        'label' => esc_html__('Slider Handle Border Radius', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .noUi-handle' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => 'meta',
            'gbx_grid_filter_visual_element_meta' => 'slider',
        ],
    ]
);

// connect color
$this->add_control(
    'gbx_grid_slider_connect_color',
    [
        'label' => esc_html__('Slider Connect Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '#000000',
        'selectors' => [
            '{{WRAPPER}} .gbx__filter__wrapper .noUi-connect' => 'background-color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_grid_filter_mode' => 'meta',
            'gbx_grid_filter_visual_element_meta' => 'slider',
        ],
    ]
);
