<?php

//abort if file is called directly
if (!defined('WPINC')) {
    die;
}

$this->start_controls_section(
    'filter_section_content',
    [
        'label' => esc_html__('Design Filters for your grid', 'gbx'),
    ]
);

// text control 
$this->add_control(
    'gbx_grid_filter_id',
    [
        'label' => esc_html__('GRID ID', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
    ]
);

//tabs start
$this->start_controls_tabs(
    'gbx_grid_filter_tabs'
);

//tab content start
$this->start_controls_tab(
    'gbx_grid_filter_tab_content',
    [
        'label' => esc_html__('Filter', 'gbx'),
    ]
);

require_once GBX_PLUGIN_DIR . 'widgets/load/filter-components/main-settings.php';

// end tab
$this->end_controls_tab();

// start tab
$this->start_controls_tab(
    'gbx_grid_filter_tab_style',
    [
        'label' => esc_html__('Style', 'gbx'),
    ]
);

require_once GBX_PLUGIN_DIR . 'widgets/load/filter-components/dropdowns-taxonomy.php';
require_once GBX_PLUGIN_DIR . 'widgets/load/filter-components/checkboxes-taxonomy.php';

require_once GBX_PLUGIN_DIR . 'widgets/load/filter-components/dropdowns-meta.php';
require_once GBX_PLUGIN_DIR . 'widgets/load/filter-components/checkboxes-meta.php';

require_once GBX_PLUGIN_DIR . 'widgets/load/filter-components/clear-filter.php';
require_once GBX_PLUGIN_DIR . 'widgets/load/filter-components/slider-meta.php';

require_once GBX_PLUGIN_DIR . 'widgets/load/filter-components/search-styling.php';
require_once GBX_PLUGIN_DIR . 'widgets/load/filter-components/dropdowns-orderby.php';


// divider
$this->add_control(
    'gbx_grid_filter_divider_show_more',
    [
        'type' => \Elementor\Controls_Manager::DIVIDER,
    ]
);

// Show more button typography
$this->add_group_control(
    \Elementor\Group_Control_Typography::get_type(),
    [
        'name' => 'gbx_grid_filter_show_more_typography',
        'label' => esc_html__('Show more button typography', 'gbx'),
        'selector' => '{{WRAPPER}} .gbx-show-more',
    ]
);

// Show more button color
$this->add_control(
    'gbx_grid_filter_show_more_color',
    [
        'label' => esc_html__('Show more button color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
            '{{WRAPPER}} .gbx-show-more' => 'color: {{VALUE}}',
        ],
        'default' => '#fff',
    ]
);

// Button hover color
$this->add_control(
    'gbx_grid_filter_show_more_hover_color',
    [
        'label' => esc_html__('Show more button hover color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
            '{{WRAPPER}} .gbx-show-more:hover' => 'color: {{VALUE}}',
        ],
        'default' => '#fff',
    ]
);

// Show more button background color
$this->add_control(
    'gbx_grid_filter_show_more_background_color',
    [
        'label' => esc_html__('Show more button background color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
            '{{WRAPPER}} .gbx-show-more' => 'background-color: {{VALUE}}',
        ],
        'default' => '#000',
    ]
);

// button background hover color
$this->add_control(
    'gbx_grid_filter_show_more_background_hover_color',
    [
        'label' => esc_html__('Show more button background hover color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
            '{{WRAPPER}} .gbx-show-more:hover' => 'background-color: {{VALUE}}',
        ],
        'default' => '#000',
    ]
);

// border group control - Group_Control_Border
$this->add_group_control(
    \Elementor\Group_Control_Border::get_type(),
    [
        'name' => 'gbx_grid_filter_show_more_border',
        'label' => esc_html__('Show more button border', 'gbx'),
        'selector' => '{{WRAPPER}} .gbx-show-more',
    ]
);

// show more button border radius
$this->add_responsive_control(
    'gbx_grid_filter_show_more_border_radius',
    [
        'label' => esc_html__('Show more button border radius', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%'],
        'selectors' => [
            '{{WRAPPER}} .gbx-show-more' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
    ]
);

// Button padding
$this->add_responsive_control(
    'gbx_grid_filter_show_more_padding',
    [
        'label' => esc_html__('Show more button padding', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%'],
        'selectors' => [
            '{{WRAPPER}} .gbx-show-more' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
    ]
);

// Button margin
$this->add_responsive_control(
    'gbx_grid_filter_show_more_margin',
    [
        'label' => esc_html__('Show more button margin', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%'],
        'selectors' => [
            '{{WRAPPER}} .gbx-show-more' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
    ]
);

//Button width
$this->add_responsive_control(
    'gbx_grid_filter_show_more_width',
    [
        'label' => esc_html__('Show more button width', 'gbx'),
        'type' => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['px', '%'],
        'range' => [
            '%' => [
                'min' => 0,
                'max' => 100,
            ],
            'px' => [
                'min' => 0,
                'max' => 1000,
            ],
        ],
        'selectors' => [
            '{{WRAPPER}} .gbx-show-more' => 'width: {{SIZE}}{{UNIT}};',
        ],
    ]
);



$this->end_controls_tab();
$this->end_controls_tabs();
$this->end_controls_section();
