<?php

//abort if file is called directly
if (!defined('WPINC')) {
    die;
}

$this->start_controls_section(
    'section_content',
    [
        'label' => esc_html__('Design your Grid ( Single Block )', 'gbx'),
    ]
);


$repeater = new \Elementor\Repeater();

$repeater->add_control(
    'list_title',
    [
        'label' => esc_html__('Admin Title', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
        'default' => esc_html__('List Title', 'gbx'),
        'label_block' => false,
        'description' => esc_html__('This is to help you to identify the block easily', 'gbx'),
    ]
);


// add three tabs
$repeater->start_controls_tabs('gbx_repeater_tabs');



// add tab content
$repeater->start_controls_tab(
    'gbx_repeater_main_settings',
    [
        'label' => esc_html__('Field Type', 'gbx'),
    ]
);

require_once GBX_PLUGIN_DIR . 'widgets/load/components/field-configuration.php';

$repeater->end_controls_tab();

$repeater->start_controls_tab(
    'gbx_repeater_tab_styling',
    [
        'label' => esc_html__('Styling', 'gbx'),
    ]
);


require_once GBX_PLUGIN_DIR . 'widgets/load/components/styling.php';

$repeater->end_controls_tab();

$repeater->start_controls_tab(
    'gbx_repeater_tab_hover',
    [
        'label' => esc_html__('Hover', 'gbx'),
    ]
);

require_once GBX_PLUGIN_DIR . 'widgets/load/components/hover.php';

$repeater->end_controls_tab();

$repeater->start_controls_tab(
    'gbx_repeater_tab_advanced',
    [
        'label' => esc_html__('Advanced', 'gbx'),
    ]
);

require_once GBX_PLUGIN_DIR . 'widgets/load/components/advanced.php';

$repeater->end_controls_tab();

$repeater->end_controls_tabs();

$this->add_control(
    'gbx_grid_designer',
    [
        'label' => esc_html__('This module gives control over each block', 'gbx'),
        'type' => \Elementor\Controls_Manager::REPEATER,
        'fields' => $repeater->get_controls(),
        'default' => [
            [
                'list_title' => esc_html__('Title #1', 'gbx'),
            ],
        ],
        'title_field' => '{{{ list_title }}}',
    ]
);


$this->end_controls_section();
