<?php

// if accessed directly than exit
if (!defined('ABSPATH')) {
    exit;
}

$this->start_controls_section(
    'gbx_pagination',
    [
        'label' => esc_html__('Pagination', 'gbx'),
    ]
);

// text control 
$this->add_control(
    'gbx_grid_id',
    [
        'label' => esc_html__('GRID ID', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
    ]
);


$this->add_control(
    'gbx_pagination_type',
    [
        'label' => esc_html__('Pagination Type', 'gbx'),
        'type' => \Elementor\Controls_Manager::SELECT,
        'default' => 'none',
        'options' => [
            'none' => esc_html__('None', 'gbx'),
            'loadmore' => esc_html__('Load More', 'gbx'),
            'infinite' => esc_html__('Infinite Scroll', 'gbx'),
            'pagination' => esc_html__('Numbered', 'gbx'),
        ],
    ]
);

//two tabs for settings and style of pagination
$this->start_controls_tabs('gbx_pagination_tabs');

//start settings tab
$this->start_controls_tab(
    'gbx_pagination_settings_tab',
    [
        'label' => esc_html__('Settings', 'gbx'),
        'condition' => [
            'gbx_pagination_type!' => 'none',
        ],
    ]
);



$this->add_control(
    'gbx_pagination_load_more_text',
    [
        'label' => esc_html__('Load More Text', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
        'default' => esc_html__('Load More', 'gbx'),
        'condition' => [
            'gbx_pagination_type' => 'loadmore',
        ],
    ]
);

$this->add_control(
    'gbx_pagination_load_more_loading_text',
    [
        'label' => esc_html__('Loading Text', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
        'default' => esc_html__('Loading...', 'gbx'),
        'condition' => [
            'gbx_pagination_type' => 'loadmore',
        ],
    ]
);

$this->add_control(
    'gbx_pagination_load_more_no_more_text',
    [
        'label' => esc_html__('No More Text', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
        'default' => esc_html__('No More Posts', 'gbx'),
        'condition' => [
            'gbx_pagination_type' => 'loadmore',
        ],
    ]
);

// loading animation append class
$this->add_control(
    'gbx_pagination_load_more_loading_animation',
    [
        'label' => esc_html__('Loading Animation', 'gbx'),
        'type' => \Elementor\Controls_Manager::SELECT,
        'default' => 'none',
        'options' => [
            'none' => esc_html__('None', 'gbx'),
            'gbx-loading-animation-1' => esc_html__('Animation 1', 'gbx'),
            'gbx-loading-animation-2' => esc_html__('Animation 2', 'gbx'),
            'gbx-loading-animation-3' => esc_html__('Animation 3', 'gbx'),
        ],
        'condition' => [
            'gbx_pagination_type' => 'infinite',
        ],
    ]
);

$this->add_control(
    'gbx_pagination_numbered_prev_text',
    [
        'label' => esc_html__('Previous Text', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
        'default' => esc_html__('Previous', 'gbx'),
        'condition' => [
            'gbx_pagination_type' => 'pagination',
        ],
    ]
);

$this->add_control(
    'gbx_pagination_numbered_next_text',
    [
        'label' => esc_html__('Next Text', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
        'default' => esc_html__('Next', 'gbx'),
        'condition' => [
            'gbx_pagination_type' => 'pagination',
        ],
    ]
);

$this->add_control(
    'gbx_pagination_numbered_prev_icon',
    [
        'label' => esc_html__('Previous Icon', 'gbx'),
        'type' => \Elementor\Controls_Manager::ICONS,
        'condition' => [
            'gbx_pagination_type' => 'pagination',
        ],
    ]
);

$this->add_control(
    'gbx_pagination_numbered_next_icon',
    [
        'label' => esc_html__('Next Icon', 'gbx'),
        'type' => \Elementor\Controls_Manager::ICONS,
        'condition' => [
            'gbx_pagination_type' => 'pagination',
        ],
    ]
);

// loading spinner type roller, ripple, ring, ellipsis, grid, spinner
$this->add_control(
    'gbx_pagination_loading_spinner_type',
    [
        'label' => esc_html__('Loading Spinner Type', 'gbx'),
        'type' => \Elementor\Controls_Manager::SELECT,
        'default' => 'roller',
        'options' => [
            'roller' => esc_html__('Roller', 'gbx'),
            'ripple' => esc_html__('Ripple', 'gbx'),
            'ring' => esc_html__('Ring', 'gbx'),
            'ellipsis' => esc_html__('Ellipsis', 'gbx'),
            'grid' => esc_html__('Grid', 'gbx'),
            'spinner' => esc_html__('Spinner', 'gbx'),
        ],
        'condition' => [
            'gbx_pagination_type!' => ['none', 'loadmore'],
        ],
    ]
);

//spiiner alignment , horizontal , flex css - justify-content
$this->add_control(
    'gbx_pagination_loading_spinner_align',
    [
        'label' => esc_html__('Alignment of spinner in the container', 'gbx'),
        'type' => \Elementor\Controls_Manager::CHOOSE,
        'options' => [
            'left' => [
                'title' => esc_html__('Left', 'gbx'),
                'icon' => 'fa fa-align-left',
            ],
            'center' => [
                'title' => esc_html__('Center', 'gbx'),
                'icon' => 'fa fa-align-center',
            ],
            'right' => [
                'title' => esc_html__('Right', 'gbx'),
                'icon' => 'fa fa-align-right',
            ],
        ],
        'selectors' => [
            '{{WRAPPER}} .gbx-spinner-main' => 'justify-content: {{VALUE}};',
        ],
        'default' => 'center',
        'condition' => [
            'gbx_pagination_type!' => ['none', 'loadmore', 'pagination'],
        ],
    ]
);



//end settings tab
$this->end_controls_tab();

//start style tab
$this->start_controls_tab(
    'gbx_pagination_style_tab',
    [
        'label' => esc_html__('Style', 'gbx'),
        'condition' => [
            'gbx_pagination_type!' => 'none',
        ],
    ]
);


//pagination style

//pagination container justify-content
$this->add_control(
    'gbx_pagination_container_align',
    [
        'label' => esc_html__('Alignment of pagination in the container', 'gbx'),
        'type' => \Elementor\Controls_Manager::CHOOSE,
        'options' => [
            'left' => [
                'title' => esc_html__('Left', 'gbx'),
                'icon' => 'fa fa-align-left',
            ],
            'center' => [
                'title' => esc_html__('Center', 'gbx'),
                'icon' => 'fa fa-align-center',
            ],
            'right' => [
                'title' => esc_html__('Right', 'gbx'),
                'icon' => 'fa fa-align-right',
            ],
        ],
        'selectors' => [
            '{{WRAPPER}} .gbx__pagination_container' => 'justify-content: {{VALUE}};',
        ],
        'default' => 'center',
        'condition' => [
            'gbx_pagination_type' => 'pagination',
        ],
    ]
);


//paginatiion font control
$this->add_group_control(
    \Elementor\Group_Control_Typography::get_type(),
    [
        'name' => 'gbx_pagination_typography',
        'label' => esc_html__('Typography', 'gbx'),
        'selector' => '{{WRAPPER}} .gbx__pagination_container .gbx__pagination_numbered',
        'condition' => [
            'gbx_pagination_type' => 'pagination',
        ],
    ]
);

// icon size
$this->add_responsive_control(
    'gbx_pagination_icon_size',
    [
        'label' => esc_html__('Icon Size', 'gbx'),
        'type' => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['px', 'em', 'rem'],
        'range' => [
            'px' => [
                'min' => 0,
                'max' => 100,
                'step' => 1,
            ],
            'em' => [
                'min' => 0,
                'max' => 10,
                'step' => 0.1,
            ],
            'rem' => [
                'min' => 0,
                'max' => 10,
                'step' => 0.1,
            ],
        ],
        'selectors' => [
            '{{WRAPPER}} .gbx__page__prev svg, .gbx__page__prev i , .gbx__page__next svg, .gbx__page__next i' => 'font-size: {{SIZE}}{{UNIT}};',
            '{{WRAPPER}} .gbx__page__prev svg, .gbx__page__prev i , .gbx__page__next svg, .gbx__page__next i' => 'width: {{SIZE}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'pagination',
        ],
    ]
);

//color
$this->add_control(
    'gbx_pagination_color',
    [
        'label' => esc_html__('Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
            '{{WRAPPER}} .gbx__pagination__item' => 'color: {{VALUE}};',
            '{{WRAPPER}} i' => 'color: {{VALUE}};',
            '{{WRAPPER}} svg' => 'fill: {{VALUE}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'pagination',
        ],
    ]
);



// background color
$this->add_control(
    'gbx_pagination_background_color',
    [
        'label' => esc_html__('Background Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'selectors' => [
            '{{WRAPPER}} .gbx__pagination__item' => 'background-color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'pagination',
        ],
    ]
);


// active color
$this->add_control(
    'gbx_pagination_active_color',
    [
        'label' => esc_html__('Active Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => 'white',
        'selectors' => [
            '{{WRAPPER}} .gbx-active' => 'color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'pagination',
        ],
    ]
);


// active background color
$this->add_control(
    'gbx_pagination_active_background_color',
    [
        'label' => esc_html__('Active Background Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => 'red',
        'selectors' => [
            '{{WRAPPER}} .gbx-active' => 'background-color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'pagination',
        ],
    ]
);

//previous color
$this->add_control(
    'gbx_pagination_previous_color',
    [
        'label' => esc_html__('Previous Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => 'white',
        'selectors' => [
            '{{WRAPPER}} .gbx__page__prev' => 'color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'pagination',
        ],
    ]
);

// previous background color
$this->add_control(
    'gbx_pagination_previous_background_color',
    [
        'label' => esc_html__('Previous Background Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => 'red',
        'selectors' => [
            '{{WRAPPER}} .gbx__page__prev' => 'background-color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'pagination',
        ],
    ]
);

// next text color
$this->add_control(
    'gbx_pagination_next_color',
    [
        'label' => esc_html__('Next Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => 'white',
        'selectors' => [
            '{{WRAPPER}} .gbx__page__next' => 'color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'pagination',
        ],
    ]
);

// next background color
$this->add_control(
    'gbx_pagination_next_background_color',
    [
        'label' => esc_html__('Next Background Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => 'red',
        'selectors' => [
            '{{WRAPPER}} .gbx__page__next' => 'background-color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'pagination',
        ],
    ]
);

//border
$this->add_group_control(
    \Elementor\Group_Control_Border::get_type(),
    [
        'name' => 'gbx_pagination_border',
        'label' => esc_html__('Border', 'gbx'),
        'selector' => '{{WRAPPER}} .gbx__pagination__item',
        'condition' => [
            'gbx_pagination_type' => 'pagination',
        ],
    ]
);

//border radius
$this->add_responsive_control(
    'gbx_pagination_border_radius',
    [
        'label' => esc_html__('Border Radius', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', 'rem'],
        'selectors' => [
            '{{WRAPPER}} .gbx__pagination__item' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'pagination',
        ],
    ]
);

//border box shadow
$this->add_group_control(
    \Elementor\Group_Control_Box_Shadow::get_type(),
    [
        'name' => 'gbx_pagination_box_shadow',
        'label' => esc_html__('Box Shadow', 'gbx'),
        'selector' => '{{WRAPPER}} .gbx__pagination__item',
        'condition' => [
            'gbx_pagination_type' => 'pagination',
        ],
    ]
);


// padding
$this->add_responsive_control(
    'gbx_pagination_padding',
    [
        'label' => esc_html__('Padding', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', 'rem'],
        'selectors' => [
            '{{WRAPPER}} .gbx__pagination__item' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'pagination',
        ],
    ]
);

// margin
$this->add_responsive_control(
    'gbx_pagination_margin',
    [
        'label' => esc_html__('Margin', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', 'em', 'rem'],
        'selectors' => [
            '{{WRAPPER}} .gbx__pagination__item' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'pagination',
        ],
    ]
);

// gbx-button-loadmore center justify
$this->add_responsive_control(
    'gbx_pagination_load_more_align',
    [
        'label' => esc_html__('Alignment of button in the container', 'gbx'),
        'type' => \Elementor\Controls_Manager::CHOOSE,
        'options' => [
            'left' => [
                'title' => esc_html__('Left', 'gbx'),
                'icon' => 'fa fa-align-left',
            ],
            'center' => [
                'title' => esc_html__('Center', 'gbx'),
                'icon' => 'fa fa-align-center',
            ],
            'right' => [
                'title' => esc_html__('Right', 'gbx'),
                'icon' => 'fa fa-align-right',
            ],
        ],
        'default' => 'center',
        'selectors' => [
            '{{WRAPPER}} .gbx-button-loadmore' => 'text-align: {{VALUE}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'loadmore',
        ],
    ]
);

//dividers
$this->add_control(
    'gbx_pagination_divider_1_loadmore',
    [
        'type' => \Elementor\Controls_Manager::DIVIDER,
        'condition' => [
            'gbx_pagination_type' => 'loadmore',
        ],
    ]
);

//heading
$this->add_control(
    'gbx_pagination_heading_load_more_button',
    [
        'label' => esc_html__('Button specific settings', 'gbx'),
        'type' => \Elementor\Controls_Manager::HEADING,
        'condition' => [
            'gbx_pagination_type' => 'loadmore',
        ],
    ]
);

// button typography
$this->add_group_control(
    \Elementor\Group_Control_Typography::get_type(),
    [
        'name' => 'gbx_pagination_load_more_typography',
        'label' => esc_html__('Typography', 'gbx'),
        'selector' => '{{WRAPPER}} .gbx-button-loadmore button',
        'condition' => [
            'gbx_pagination_type' => 'loadmore',
        ],
    ]
);

// color
$this->add_control(
    'gbx_pagination_load_more_color',
    [
        'label' => esc_html__('Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '#fff',
        'selectors' => [
            '{{WRAPPER}} .gbx-button-loadmore button' => 'color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'loadmore',
        ],
    ]
);

// background color
$this->add_control(
    'gbx_pagination_load_more_background_color',
    [
        'label' => esc_html__('Background Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '#000',
        'selectors' => [
            '{{WRAPPER}} .gbx-button-loadmore button' => 'background-color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'loadmore',
        ],
    ]
);

// button width
$this->add_responsive_control(
    'gbx_pagination_load_more_width',
    [
        'label' => esc_html__('Width', 'gbx'),
        'type' => \Elementor\Controls_Manager::SLIDER,
        'size_units' => ['px', '%', 'em'],
        'range' => [
            'px' => [
                'min' => 0,
                'max' => 1000,
                'step' => 1,
            ],
            '%' => [
                'min' => 0,
                'max' => 100,
            ],
            'em' => [
                'min' => 0,
                'max' => 100,
            ],
        ],
        'default' => [
            'unit' => 'px',
            'size' => 200,
        ],
        'selectors' => [
            '{{WRAPPER}} .gbx-button-loadmore button' => 'width: {{SIZE}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'loadmore',
        ],
    ]
);

// button text align
$this->add_responsive_control(
    'gbx_pagination_load_more_text_align',
    [
        'label' => esc_html__('Text Align Button', 'gbx'),
        'type' => \Elementor\Controls_Manager::CHOOSE,
        'options' => [
            'left' => [
                'title' => esc_html__('Left', 'gbx'),
                'icon' => 'fa fa-align-left',
            ],
            'center' => [
                'title' => esc_html__('Center', 'gbx'),
                'icon' => 'fa fa-align-center',
            ],
            'right' => [
                'title' => esc_html__('Right', 'gbx'),
                'icon' => 'fa fa-align-right',
            ],
        ],
        'default' => 'center',
        'selectors' => [
            '{{WRAPPER}} .gbx-button-loadmore button' => 'text-align: {{VALUE}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'loadmore',
        ],
    ]
);




// border with default as none
$this->add_group_control(
    \Elementor\Group_Control_Border::get_type(),
    [
        'name' => 'gbx_pagination_load_more_border',
        'label' => esc_html__('Border', 'gbx'),
        'default' => '1px',
        'selector' => '{{WRAPPER}} .gbx-button-loadmore button',
        'condition' => [
            'gbx_pagination_type' => 'loadmore',
        ],
    ]
);

// border radius
$this->add_control(
    'gbx_pagination_load_more_border_radius',
    [
        'label' => esc_html__('Border Radius', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'default' => [
            'top' => '0',
            'right' => '0',
            'bottom' => '0',
            'left' => '0',
            'unit' => 'px',
            'isLinked' => false,
        ],
        'selectors' => [
            '{{WRAPPER}} .gbx-button-loadmore button' => 'border-radius: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'loadmore',
        ],
    ]
);

// divider
$this->add_control(
    'gbx_pagination_load_more_divider',
    [
        'type' => \Elementor\Controls_Manager::DIVIDER,
        'condition' => [
            'gbx_pagination_type' => 'loadmore',
        ],
    ]
);

// hover color
$this->add_control(
    'gbx_pagination_load_more_hover_color',
    [
        'label' => esc_html__('Hover Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '#fff',
        'selectors' => [
            '{{WRAPPER}} .gbx-button-loadmore button:hover' => 'color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'loadmore',
        ],
    ]
);

// hover background color
$this->add_control(
    'gbx_pagination_load_more_hover_background_color',
    [
        'label' => esc_html__('Hover Background Color', 'gbx'),
        'type' => \Elementor\Controls_Manager::COLOR,
        'default' => '#000',
        'selectors' => [
            '{{WRAPPER}} .gbx-button-loadmore button:hover' => 'background-color: {{VALUE}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'loadmore',
        ],
    ]
);

// hover border color
// $this->add_control(
//     'gbx_pagination_load_more_hover_border_color',
//     [
//         'label' => esc_html__('Hover Border Color', 'gbx'),
//         'type' => \Elementor\Controls_Manager::COLOR,
//         'default' => '#000',
//         'selectors' => [
//             '{{WRAPPER}} .gbx-button-loadmore button:hover' => 'border-color: {{VALUE}};',
//         ],
//         'condition' => [
//             'gbx_pagination_type' => 'loadmore',
//         ],
//     ]
// );

// hover border group control
$this->add_group_control(
    \Elementor\Group_Control_Border::get_type(),
    [
        'name' => 'gbx_pagination_load_more_hover_border',
        'label' => esc_html__('Hover Border', 'gbx'),
        'default' => '1px',
        'selector' => '{{WRAPPER}} .gbx-button-loadmore button:hover',
        'condition' => [
            'gbx_pagination_type' => 'loadmore',
        ],
    ]
);

// button padding
$this->add_responsive_control(
    'gbx_pagination_load_more_button_padding',
    [
        'label' => esc_html__('Button Padding', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'default' => [
            'top' => '10',
            'right' => '20',
            'bottom' => '10',
            'left' => '20',
            'unit' => 'px',
            'isLinked' => false,
        ],
        'selectors' => [
            '{{WRAPPER}} .gbx-button-loadmore button' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'loadmore',
        ],
    ]
);

// margin
$this->add_responsive_control(
    'gbx_pagination_load_more_margin',
    [
        'label' => esc_html__('Margin', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'selectors' => [
            '{{WRAPPER}} .gbx-button-loadmore' => 'margin: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'loadmore',
        ],
    ]
);

// padding
$this->add_responsive_control(
    'gbx_pagination_load_more_padding',
    [
        'label' => esc_html__('Padding', 'gbx'),
        'type' => \Elementor\Controls_Manager::DIMENSIONS,
        'size_units' => ['px', '%', 'em'],
        'default' => [
            'top' => '20',
            'right' => '0',
            'bottom' => '20',
            'left' => '0',
            'isLinked' => true,
        ],
        'selectors' => [
            '{{WRAPPER}} .gbx-button-loadmore' => 'padding: {{TOP}}{{UNIT}} {{RIGHT}}{{UNIT}} {{BOTTOM}}{{UNIT}} {{LEFT}}{{UNIT}};',
        ],
        'condition' => [
            'gbx_pagination_type' => 'loadmore',
        ],
    ]
);


// divider
$this->add_control(
    'gbx_pagination_load_more_divider_2',
    [
        'type' => \Elementor\Controls_Manager::DIVIDER,
        'condition' => [
            'gbx_pagination_type' => 'loadmore',
        ],
    ]
);





$this->end_controls_tab();

//end tabs
$this->end_controls_tabs();




//end
$this->end_controls_section();
