<?php

// if accessed directly than exit
if (!defined('ABSPATH')) {
    exit;
}

$this->start_controls_section(
    'gbx_schema',
    [
        'label' => esc_html__('Schema', 'gbx'),
        'condition' => [
            'enable_schema' => 'yes',
        ],
    ]
);


// schema type by google
$this->add_control(
    'schema_type',
    [
        'label' => esc_html__('Schema Type', 'gbx'),
        'type' => \Elementor\Controls_Manager::SELECT,
        'default' => 'Article',
        'options' => [
            'Article' => esc_html__('Article', 'gbx'),
            'BlogPosting' => esc_html__('BlogPosting', 'gbx'),
            'NewsArticle' => esc_html__('NewsArticle', 'gbx'),
            'Event' => esc_html__('Event', 'gbx'),
            'Product' => esc_html__('Product', 'gbx'),
            'Recipe' => esc_html__('Recipe', 'gbx'),
            'Review' => esc_html__('Review', 'gbx'),
            'LocalBusiness' => esc_html__('LocalBusiness', 'gbx'),
        ],
        'condition' => [
            'enable_schema' => 'yes',
        ],
    ]
);

// organization name
$this->add_control(
    'organization_name',
    [
        'label' => esc_html__('Organization Name', 'gbx'),
        'type' => \Elementor\Controls_Manager::TEXT,
        'condition' => [
            'enable_schema' => 'yes',
        ],
    ]
);

// organization logo
$this->add_control(
    'organization_logo',
    [
        'label' => esc_html__('Organization Logo', 'gbx'),
        'type' => \Elementor\Controls_Manager::MEDIA,
        'condition' => [
            'enable_schema' => 'yes',
        ],
    ]
);

// organization url
$this->add_control(
    'organization_url',
    [
        'label' => esc_html__('Organization URL', 'gbx'),
        'type' => \Elementor\Controls_Manager::URL,
        'default' => [
            'url' => home_url(),
            'is_external' => false,
        ],
        'condition' => [
            'enable_schema' => 'yes',
        ],
    ]
);


//end
$this->end_controls_section();
